﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using UnityEngine;

namespace Mod
{
    public enum ResistData
    {
        MidasResist,
        CrusherResist,
        ChampionResist,
        ExplosiveResist,
        ZeloVelocityResist,
        BarrierResist,
        ZombieBiteResist,
        VoidTransformResist,
        RottenGodResist,
        BleedResist

    }


    public class BodyRegenPassive : MonoBehaviour
    {
        public Liquid blood1;
        public LimbBehaviour limb;
        public float TimeDelay = 1.5f;
        public bool Active = true;
        public List<ResistData> Resists = new List<ResistData>();

        public virtual void Start()
        {

            limb = GetComponent<LimbBehaviour>();
            PhysicalBehaviour physicalBehaviour = limb.PhysicalBehaviour;
            blood1 = limb.GetOriginalBloodType();
            StartCoroutine(Heal());


        }

        public virtual void OnHealCycle()
        {


        }
        public virtual void Nullificator()
        {
            Destroy(this);
        }


        public virtual IEnumerator Heal()
        {
            while (Active == true)
            {

                yield return new WaitForEndOfFrame();
                foreach (var Personlimbs in limb.Person.Limbs)
                {

                    StartCoroutine(HealLimbStats(Personlimbs));
                }


                yield return new WaitForSeconds(TimeDelay);
                OnHealCycle();
            }


        }

        public virtual IEnumerator HealLimbStats(LimbBehaviour limb)
        {
            limb.HealBone();
            limb.Health = limb.InitialHealth;
            limb.Numbness = 0f;
            limb.CirculationBehaviour.HealBleeding();
            limb.CirculationBehaviour.BloodFlow = 1f;


            if (limb.CirculationBehaviour.GetAmount(blood1) <= 1f)
            {
                limb.CirculationBehaviour.AddLiquid(blood1, 1f);
            }



            limb.BruiseCount = (ushort)0;
            limb.CirculationBehaviour.GunshotWoundCount = (ushort)0;
            limb.CirculationBehaviour.StabWoundCount = (ushort)0;
            limb.Person.Consciousness = 1f;
            limb.Person.OxygenLevel = 1f;
            limb.LungsPunctured = false;
            limb.Person.Braindead = false;
            limb.Person.BrainDamaged = false;
            limb.Person.AdrenalineLevel = 0f;
            StartCoroutine(HealSkin(limb));
            StartCoroutine(HealRot(limb));
            StartCoroutine(HealAcidDamage(limb));
            StartCoroutine(HealBurnDamage(limb));
            yield return new WaitForEndOfFrame();
        }

        internal IEnumerator HealSkin(LimbBehaviour limb)
        {
            while (limb.SkinMaterialHandler.damagePoints.Max(new Func<Vector4, float>(VectorZ)) > 0f)
            {
                for (int i = 0; i < limb.SkinMaterialHandler.damagePoints.Length; i++)
                {
                    Vector4[] damagePoints = limb.SkinMaterialHandler.damagePoints;
                    damagePoints[i].z = damagePoints[i].z - Time.deltaTime * 1f;
                }
                limb.SkinMaterialHandler.Sync();
                yield return new WaitForEndOfFrame();
            }
            yield break;
        }

        internal IEnumerator HealBurnDamage(LimbBehaviour limb)
        {
            while ((double)limb.PhysicalBehaviour.BurnProgress > 0.1)
            {
                limb.PhysicalBehaviour.BurnProgress -= Time.deltaTime * 0.1f;
                yield return (object)new WaitForEndOfFrame();
            }
            limb.PhysicalBehaviour.BurnProgress = 0.0f;
        }

        internal IEnumerator HealAcidDamage(LimbBehaviour limb)
        {
            while ((double)limb.SkinMaterialHandler.AcidProgress > 0.1)
            {
                limb.SkinMaterialHandler.AcidProgress -= Time.deltaTime * 0.1f;
                yield return (object)new WaitForEndOfFrame();
            }
            limb.SkinMaterialHandler.AcidProgress = 0.0f;
        }

        internal IEnumerator HealRot(LimbBehaviour limb)
        {
            while ((double)limb.SkinMaterialHandler.RottenProgress > 0.1)
            {
                limb.SkinMaterialHandler.RottenProgress -= Time.deltaTime * 0.1f;
                yield return (object)new WaitForEndOfFrame();
            }

        }


        private float VectorZ(Vector4 c)
        {
            return c.z;
        }

    }




    public class WeakRegen : BodyRegenPassive
    {
        public int limit;
        public override void Start()
        {
            base.Start();
        }


        public override void OnHealCycle()
        {

            if (limit > 10)
            {
                Active = false;
            }
        }

        public override IEnumerator HealLimbStats(LimbBehaviour limb)
        {
            if (limb.Health < 0.2f)
            {
                limit++;
            }

            limb.HealBone();
            limb.Health = limb.InitialHealth;
            limb.Numbness = 0f;
            limb.CirculationBehaviour.HealBleeding();
            limb.CirculationBehaviour.BloodFlow = 1f;

            limb.BruiseCount = (ushort)0;
            limb.CirculationBehaviour.GunshotWoundCount = (ushort)0;
            limb.CirculationBehaviour.StabWoundCount = (ushort)0;
            limb.Person.Consciousness = 1f;
            limb.Person.OxygenLevel = 1f;
            limb.LungsPunctured = false;
            limb.Person.Braindead = false;
            limb.Person.BrainDamaged = false;
            limb.Person.AdrenalineLevel = 0f;

            if (limb.CirculationBehaviour.GetAmount(blood1) <= 1f)
            {
                
                limb.CirculationBehaviour.AddLiquid(blood1, 1f);
            }

      

                limb.BruiseCount = (ushort)0;
            limb.CirculationBehaviour.GunshotWoundCount = (ushort)0;
            limb.CirculationBehaviour.StabWoundCount = (ushort)0;
            limb.Person.Consciousness = 1f;
            limb.Person.OxygenLevel = 1f;
            limb.LungsPunctured = false;
            limb.Person.Braindead = false;
            limb.Person.BrainDamaged = false;
            limb.Person.AdrenalineLevel = 0f;
            StartCoroutine(HealSkin(limb));
            StartCoroutine(HealRot(limb));
            StartCoroutine(HealAcidDamage(limb));
            StartCoroutine(HealBurnDamage(limb));
            yield return new WaitForEndOfFrame();
        }


    }


    public class ImplantRegen : BodyRegenPassive
    {
        public override IEnumerator HealLimbStats(LimbBehaviour limb)
        {

            limb.Person.Consciousness = 1f;
            limb.Person.OxygenLevel = 1f;
            limb.Person.AdrenalineLevel = 0f;
            limb.Person.ShockLevel = 0f;
            limb.CirculationBehaviour.HealBleeding();
            limb.Person.BrainDamaged = false;
            
            limb.LungsPunctured = false;
            yield return new WaitForEndOfFrame();
        }
    }



    public class ConsciousnessRegen : BodyRegenPassive
    {
        public override IEnumerator HealLimbStats(LimbBehaviour limb)
        {

            limb.Person.Consciousness = 1f;
            limb.Person.AdrenalineLevel = 0f;
            limb.Person.ShockLevel = 0f;
            yield return new WaitForEndOfFrame();
        }
    }


    public class AbsorberPower : BodyRegenPassive
    {
        

        private float hpchela;

        public float restrains = 10f;
        public bool upgraded = false;
        private bool started = false;
        public override void Start()
        {
            base.Start();
            

            
       


        }


        public override IEnumerator Heal()
        {
            while (Active)
            {

                yield return new WaitForEndOfFrame();
                    StartCoroutine(HealLimbStats(limb));
                yield return new WaitForSeconds(TimeDelay);
                OnHealCycle();
            }


        }




        public override IEnumerator HealLimbStats(LimbBehaviour limb)
        {
            if(restrains <= 6)
            {
                limb.HealBone();
                limb.Health = limb.InitialHealth;
                limb.Numbness = 0f;
                limb.CirculationBehaviour.HealBleeding();
                limb.CirculationBehaviour.BloodFlow = 1f;


                if (limb.CirculationBehaviour.GetAmount(blood1) <= 1f)
                {
                    limb.CirculationBehaviour.AddLiquid(blood1, 1f);
                }



                limb.BruiseCount = (ushort)0;
                limb.CirculationBehaviour.GunshotWoundCount = (ushort)0;
                limb.CirculationBehaviour.StabWoundCount = (ushort)0;
                limb.Person.Consciousness = 1f;
                limb.Person.OxygenLevel = 1f;
                limb.LungsPunctured = false;
                limb.Person.Braindead = false;
                limb.Person.BrainDamaged = false;
                limb.Person.AdrenalineLevel = 0f;
                if (restrains <= 3)
                {
                    StartCoroutine(HealSkin(limb));
                    StartCoroutine(HealRot(limb));
                    StartCoroutine(HealAcidDamage(limb));
                    StartCoroutine(HealBurnDamage(limb));
                }

                yield return new WaitForEndOfFrame();
            }
            
        }




        public void OnCollisionEnter2D(Collision2D other)
        {
            var BRP = other.gameObject.transform.root.Find("Head").GetComponent<BodyRegenPassive>();
            var rb = gameObject.GetComponent<Rigidbody2D>();


            if (rb.velocity.magnitude >= 3f && BRP == null || BRP.Resists.Contains(ResistData.CrusherResist) == false)
            {
              
                    hpchela = other.gameObject.GetComponent<LimbBehaviour>().InitialHealth;
                    other.gameObject.GetComponent<LimbBehaviour>().Crush();
                    foreach (var i in gameObject.transform.root.GetComponentsInChildren<AbsorberPower>())
                    {
                        i.restrains--;
                        i.gameObject.GetComponent<LimbBehaviour>().InitialHealth += hpchela;
                        i.gameObject.GetComponent<LimbBehaviour>().Health = gameObject.GetComponent<LimbBehaviour>().InitialHealth;
                    }
                    if (upgraded)
                    {
                        foreach (var i in other.transform.root.GetComponentsInChildren<LimbBehaviour>())
                        {

                            i.gameObject.GetComponent<LimbBehaviour>().Crush();
                        }
                    }
                
               

            }




        }
        private void rev()
        {
            if (upgraded == false)
            {
                foreach (var i in gameObject.transform.root.GetComponentsInChildren<LimbBehaviour>())
                {
                    i.gameObject.GetComponent<LimbBehaviour>().Crush();

                }

            }

        }

       




       
        


        private void upg()
        {
            if (upgraded == false)
            {
                upgraded = true;
                ModAPI.CreateParticleEffect("Spark", gameObject.transform.position);
            }
        }






    }


}
// Originally uploaded by 'Alibarda'. Do not reupload without their explicit permission.
