﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using UnityEngine;


namespace Mod
{
    public abstract class Powers : MonoBehaviour
    {
        public GameObject ObjectWithPower;
        public GameObject ObjectGlow;
        private BoxCollider2D bc;


        public abstract string powerSpriteName();
        public abstract string powerSpriteNameUpg();

        public abstract Color color1();

        public bool upgraded = false;

        public bool IsHeadPower = false;




        public virtual void Awake()
        {

            ObjectWithPower = gameObject;

            ObjectGlow = new GameObject();
            ObjectGlow.transform.parent = ObjectWithPower.transform;
            ObjectGlow.transform.localPosition = new Vector3(0f, 0f);
            ObjectGlow.transform.localScale = gameObject.transform.parent.localScale;
            //ModAPI.Notify(gameObject.transform.root.localScale);
            //ObjectGlow.transform.localRotation = ObjectWithPower.transform.localRotation;
            ObjectGlow.transform.localRotation = Quaternion.identity;
            var ObjSprite = ObjectGlow.AddComponent<SpriteRenderer>();


            if (powerSpriteName() != null)
            {
                ObjSprite.sprite = powersprites.SpriteDictionary[powerSpriteName() + ".png"];


            }
            ObjSprite.material = ModAPI.FindMaterial("VeryBright");
            ObjSprite.color = color1();
            ObjSprite.sortingLayerName = "Top";


        }



        public virtual void Nullificator()
        {
            if (upgraded == false)
            {
                ObjectGlow.GetComponent<SpriteRenderer>().color = new Color(0f, 1f, 0f, 0f);
                Destroy(ObjectGlow);
                Destroy(this);

            }

        }

        public virtual void rev()
        {

        }






        public virtual void upg()
        {
            if (upgraded == false)
            {
                upgraded = true;
                if (powerSpriteNameUpg() != null)
                {
                    ObjectGlow.GetComponent<SpriteRenderer>().sprite = powersprites.SpriteDictionary[powerSpriteNameUpg() + ".png"];
                    //foreach (var i in ObjectWithPower.transform.root.GetComponentsInChildren<PhysicalBehaviour>())
                    //{
                    //    i.gameObject.AddComponent<ImmortalityBehaviour>();
                    //}

                    
                }
                ModAPI.CreateParticleEffect("Spark", ObjectWithPower.transform.position);
            }
        }

    }

    public class AcidPower : Powers
    {
            public override string powerSpriteName()
        {
            return ("rukaudar");
        }
        public override string powerSpriteNameUpg()
        {
            return ("rukaudar1");
        }


        public override Color color1()
        {
            return new Color(0f, 1f, 0f);
        }

        public void OnCollisionEnter2D(Collision2D other)
        {
            if (other.gameObject.GetComponent<LimbBehaviour>() != null)
            {
                var limb = other.gameObject.GetComponent<LimbBehaviour>();
                var rb = ObjectWithPower.GetComponent<Rigidbody2D>();


                if (rb.velocity.magnitude >= 3f)
                {
                    if (upgraded == false)
                    {
                        limb.SkinMaterialHandler.AcidProgress += 0.4f;
                    }
                    else
                    {


                        limb.CirculationBehaviour.AddLiquid(Liquid.GetLiquid("ACID"), 1.4f);
                    }

                }

            }





        }

        public void FixedUpdate()
        {


            if (ObjectWithPower.GetComponent<Rigidbody2D>().velocity.magnitude >= 3f)
            {
                ObjectGlow.GetComponent<SpriteRenderer>().color = new Color(0f, 1f, 0f, Mathf.Clamp(gameObject.GetComponent<Rigidbody2D>().velocity.magnitude / 250f, 0f, 1f));
            }
            else
            {
                ObjectGlow.GetComponent<SpriteRenderer>().color = new Color(0f, 1f, 0f, 0f);
            }


        }


        public override void rev()
        {
            if (upgraded == false)
            {


                ObjectWithPower.gameObject.GetComponent<LimbBehaviour>().CirculationBehaviour.AddLiquid(Liquid.GetLiquid("ACID"), 1.4f);

            }

        }

    }


    //------//

    public class MidasPower : Powers
    {

        public override string powerSpriteName()
        {
            return ("rukaudar");
        }
        public override string powerSpriteNameUpg()
        {
            return ("rukaudar1");
        }

        public override Color color1()
        {
            return new Color(1f, 1f, 0f);
        }



        public void OnCollisionEnter2D(Collision2D other)
        {
            var rb = ObjectWithPower.GetComponent<Rigidbody2D>();




            if (other.gameObject.GetComponent<LimbBehaviour>() != null)
            {
                var limb = other.gameObject.GetComponent<LimbBehaviour>();
                var BRP = other.gameObject.transform.root.Find("Head").GetComponent<BodyRegenPassive>();
                if (rb.velocity.magnitude >= 3f)
                {
                    if (BRP == null || BRP.Resists.Contains(ResistData.MidasResist) == false)
                    {

                        limb.Frozen = true;
                        other.gameObject.GetOrAddComponent<SpriteRenderer>().color = new Color(1f, 0.9f, 0f, 1f);
                        other.gameObject.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Metal");
                    }
                    if (upgraded == true)
                    {

                        limb.CirculationBehaviour.AddLiquid(Liquid.GetLiquid("GoldInfection"), 1.4f);
                    }
                }
            }

        }

        public void FixedUpdate()
        {


            if (ObjectWithPower.GetComponent<Rigidbody2D>().velocity.magnitude >= 3f)
            {
                ObjectGlow.GetComponent<SpriteRenderer>().color = new Color(1f, 1f, 0f, Mathf.Clamp(gameObject.GetComponent<Rigidbody2D>().velocity.magnitude / 250f, 0f, 1f));
            }
            else
            {
                ObjectGlow.GetComponent<SpriteRenderer>().color = new Color(1f, 1f, 0f, 0f);
            }


        }
        public override void rev()
        {
            if (upgraded == false)
            {
                foreach (var i in ObjectWithPower.transform.root.GetComponentsInChildren<LimbBehaviour>())
                {
                    i.gameObject.GetComponent<LimbBehaviour>().Frozen = true;
                    i.gameObject.GetOrAddComponent<SpriteRenderer>().color = new Color(1f, 0.9f, 0f, 1f);
                    i.gameObject.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Metal");
                }

            }

        }


    }

    public class CrusherPower : Powers
    {


        public override Color color1()
        {
            return new Color(0.5f, 0.2f, 0.8f);
        }
        public override string powerSpriteName()
        {
            return ("Braslet");
        }
        public override string powerSpriteNameUpg()
        {
            return ("Braslet22");
        }

        public override void Awake()
        {
            base.Awake();

        }

        public void OnCollisionEnter2D(Collision2D other)
        {
            var rb = ObjectWithPower.GetComponent<Rigidbody2D>();
            if (other.gameObject.GetComponent<LimbBehaviour>() != null)
            {
                var limb = other.gameObject.GetComponent<LimbBehaviour>();
                var BRP = other.gameObject.transform.root.Find("Head").GetComponent<BodyRegenPassive>();
                if (rb.velocity.magnitude >= 3f)
                {
                    if (BRP == null || BRP.Resists.Contains(ResistData.CrusherResist) == false)
                    {

                        other.gameObject.GetComponent<Rigidbody2D>().velocity = rb.velocity * 2;
                        limb.BreakBone();
                        limb.Wince(20f);
                        limb.BreakingThreshold = 0f;
                        ModAPI.CreateParticleEffect("Vapor", ObjectWithPower.transform.position);
                    }
                    else
                    {
                        other.gameObject.GetComponent<Rigidbody2D>().velocity = rb.velocity * 1.1f;
                    }
                    if (upgraded == true)
                    {
                        other.gameObject.GetComponent<Rigidbody2D>().velocity = rb.velocity * 6;
                    }



                }

            }
        }
        public override void rev()
        {
            if (upgraded == false)
            {
                foreach (var i in ObjectWithPower.transform.root.GetComponentsInChildren<LimbBehaviour>())
                {
                    i.gameObject.GetComponent<Rigidbody2D>().velocity = ObjectWithPower.gameObject.GetComponent<Rigidbody2D>().velocity * -2;
                    i.gameObject.GetComponent<LimbBehaviour>().BreakBone();
                    i.gameObject.GetComponent<LimbBehaviour>().Wince(20f);
                    i.gameObject.GetComponent<LimbBehaviour>().BreakingThreshold = 0f;
                }

            }

        }

        public void FixedUpdate()
        {


            if (ObjectWithPower.GetComponent<Rigidbody2D>().velocity.magnitude >= 3f)
            {
                ObjectGlow.GetComponent<SpriteRenderer>().color = new Color(0.5f, 0.2f, 0.8f, Mathf.Clamp(gameObject.GetComponent<Rigidbody2D>().velocity.magnitude / 250f, 0f, 1f));
            }
            else
            {
                ObjectGlow.GetComponent<SpriteRenderer>().color = new Color(0.5f, 0.2f, 0.8f, 0f);
            }


        }



    }

    public class ElectroPower : Powers
    {


        public override Color color1()
        {
            return new Color(0.2f, 0.2f, 1f);
        }
        public override string powerSpriteName()
        {
            return ("Braslet");
        }
        public override string powerSpriteNameUpg()
        {
            return ("Braslet22");
        }

        public override void Awake()
        {
            base.Awake();
            foreach (var body in this.ObjectWithPower.GetComponent<LimbBehaviour>().Person.Limbs)
            {



                body.gameObject.GetComponent<PhysicalBehaviour>().Properties.Conducting = false;


            }

        }
        public override void Nullificator()
        {
            foreach (var body in this.ObjectWithPower.GetComponent<LimbBehaviour>().Person.Limbs)
            {



                body.gameObject.GetComponent<PhysicalBehaviour>().Properties.Conducting = true;


            }
            base.Nullificator();
        }

        public void OnCollisionEnter2D(Collision2D other)
        {
            var rb = ObjectWithPower.GetComponent<Rigidbody2D>();

            if (rb.velocity.magnitude >= 3f && other.gameObject.GetComponent<Undraggable>() == null)
            {

                ModAPI.CreateParticleEffect("Spark", ObjectWithPower.transform.position);
                other.gameObject.GetComponent<PhysicalBehaviour>().charge += 7f;

                if (upgraded == true)
                {
                    other.gameObject.GetComponent<PhysicalBehaviour>().charge += 80f;
                }



            }

        }
        public override void rev()
        {
            if (upgraded == false)
            {

                foreach (var i in ObjectWithPower.transform.root.GetComponentsInChildren<LimbBehaviour>())
                {
                    i.gameObject.GetComponent<PhysicalBehaviour>().Properties.Conducting = true;
                    i.gameObject.GetComponent<PhysicalBehaviour>().charge += 125f;
                }

            }

        }

        public void FixedUpdate()
        {


            if (ObjectWithPower.GetComponent<Rigidbody2D>().velocity.magnitude >= 3f)
            {
                ObjectGlow.GetComponent<SpriteRenderer>().color = new Color(0.2f, 0.2f, 1f, Mathf.Clamp(gameObject.GetComponent<Rigidbody2D>().velocity.magnitude / 250f, 0f, 1f));
            }
            else
            {
                ObjectGlow.GetComponent<SpriteRenderer>().color = new Color(0.5f, 0.2f, 0.8f, 0f);
            }


        }



    }



    public class BitePower : Powers
    {
        public override Color color1()
        {
            return new Color(0.9f, 0.1f, 0.1f, 0.3f);
        }
        public override string powerSpriteName()
        {
            return null;
        }
        public override string powerSpriteNameUpg()
        {
            return null;
        }


        private bite Bite;

        public override void Awake()
        {
            base.Awake();
            Bite = ObjectWithPower.AddComponent<bite>();
        }


        public override void Nullificator()
        {

                

                Destroy(Bite);
                Destroy(this);
            

        }



        public override void upg()
        {
            
        }

    }







    public class ElecGunPower : Powers
    {
        public override Color color1()
        {
            return new Color(0.5f, 0.2f, 0.8f, 0.3f);
        }
        public override string powerSpriteName()
        {
            return null;
        }
        public override string powerSpriteNameUpg()
        {
            return null;
        }


        private elecshoot GunComp;

        public override void Awake()
        {
            base.Awake();
            GunComp = ObjectWithPower.AddComponent<elecshoot>();
        }


        public override void Nullificator()
        {
            if (upgraded == false)
            {
                GunComp.ObjectGlow.GetComponent<SpriteRenderer>().color = new Color(0f, 1f, 0f, 0f);

                Destroy(GunComp);
                Destroy(this);
            }

        }


    }





    public class elecshoot : CanShoot
    {

        private GameObject ObjectWithPower;
        public GameObject ObjectGlow;
        private PhysicalBehaviour physicalBehaviour;
        private Vector2 barrelPosition = new Vector2(0f, 0f);
        private Vector2 barrelDirection = new Vector2(8, -1);

        bool upgr = false;

        private LineRenderer beam;
        private LayerMask layers;
        private LayerMask bounds;
        private GameObject components;

        private bool ready;

        private RaycastHit2D[] victimBuffer = new RaycastHit2D[128];


        private void Nullificator()
        {
            if (upgr == false)
            {
                Destroy(this);

            }

        }


        public void Awake()
        {
            ObjectWithPower = gameObject;
            ObjectGlow = new GameObject();
            ObjectGlow.transform.parent = ObjectWithPower.transform;
            ObjectGlow.transform.localPosition = new Vector3(0f, 0f);
            ObjectGlow.transform.localScale = new Vector3(1f, 1f);

            var RukaSprite = ObjectGlow.AddComponent<SpriteRenderer>();
            ObjectGlow.transform.localRotation = Quaternion.identity;
            RukaSprite.sprite = powersprites.SpriteDictionary["Glaz3.png"];
            RukaSprite.material = ModAPI.FindMaterial("VeryBright");
            RukaSprite.color = new Color(0.5f, 0.2f, 0.8f, 0f);
            RukaSprite.sortingLayerName = "Top";

            physicalBehaviour = GetComponent<PhysicalBehaviour>();

            layers = LayerMask.GetMask("Objects", "CollidingDebris", "Bounds");
            bounds = LayerMask.GetMask("Bounds");

            components = new GameObject("components", typeof(Optout));
            components.transform.SetParent(transform);
            components.transform.localPosition = new Vector3(0, 0);
            beam = components.AddComponent<LineRenderer>();
            beam.SetPositions(new[] { Vector3.zero, Vector3.right * 1000 });
            beam.useWorldSpace = false;
            beam.sharedMaterial = ModAPI.FindMaterial("VeryBright");
            beam.sortingLayerName = "Bottom";


            beam.enabled = false;

            ready = true;



        }
        public void Use() => Shoot();


        public override void Shoot()
        {
            var pos = BarrelPosition;
            var dir = BarrelDirection;



            if (ready == true && upgr == true)
            {
                StartCoroutine(Fire());
            }







        }


        private void upg()
        {
            if (upgr == false)
            {
                upgr = true;
                ObjectGlow.GetComponent<SpriteRenderer>().color = new Color(0.5f, 0.2f, 0.8f, 0.3f);
                ModAPI.Notify("Use Head to shoot laser beam");
                ModAPI.CreateParticleEffect("Spark", ObjectWithPower.transform.position);
            }
        }



        private IEnumerator Fire()
        {
            const int iterations = 8;
            const float duration = 0.5f;

            const float interval = duration / iterations;

            beam.startColor = new Color(0.5f, 0.2f, 0.8f, 0.1f);
            beam.endColor = new Color(0.5f, 0.2f, 0.8f, 0.01f);
            beam.widthMultiplier = 0.1f;



            ready = false;
            beam.enabled = true;
            for (int i = 0; i < iterations; i++)
            {
                var end = Physics2D.Raycast(BarrelPosition, BarrelDirection, 20000, bounds);
                var endPos = end.transform == null ? (Vector3)BarrelPosition + (Vector3)BarrelDirection * 20000 : (Vector3)end.point;
                var victimCount = Physics2D.LinecastNonAlloc(BarrelPosition, endPos, victimBuffer, layers);
                beam.SetPosition(1, components.transform.InverseTransformPoint(endPos));

                for (int n = 0; n < victimCount; n++)
                {
                    var victim = victimBuffer[n];

                    ModAPI.CreateParticleEffect("Spark", victim.point);




                    victim.transform.TryGetComponent(out PhysicalBehaviour ph);
                    ph.charge += 10;




                }

                physicalBehaviour.rigidbody.AddRelativeForce(new Vector2(-0.1f * transform.localScale.normalized.x, 0), ForceMode2D.Impulse);
                yield return new WaitForSeconds(interval);
            }
            beam.enabled = false;
            yield return new WaitForSeconds(0.6f);
            ready = true;
        }















        public override Vector2 BarrelPosition { get { return transform.TransformPoint(barrelPosition); } }

        public Vector2 BarrelDirection { get { return transform.TransformDirection(barrelDirection) * transform.localScale.x; } }


    }






    public class ChampionPower : Powers
    {

        private float time = 1;
        public override Color color1()
        {
            return new Color(0.5f, 0.2f, 0.8f);
        }
        public override string powerSpriteName()
        {
            return ("Braslet");
        }
        public override string powerSpriteNameUpg()
        {
            return ("Braslet22");
        }




        public override void Awake()
        {
            base.Awake();
            StartCoroutine(lechenie());


        }

        public void OnCollisionEnter2D(Collision2D other)
        {
            var rb = ObjectWithPower.GetComponent<Rigidbody2D>();
            if (other.gameObject.GetComponent<LimbBehaviour>() != null)
            {
                var limb = other.gameObject.GetComponent<LimbBehaviour>();
                var BRP = other.gameObject.transform.root.Find("Head").GetComponent<BodyRegenPassive>();
                if (rb.velocity.magnitude >= 3f)
                {
                    if (BRP == null || BRP.Resists.Contains(ResistData.ChampionResist) == false)
                    {
                        limb.BreakBone();
                        limb.Wince(20f);
                        limb.BreakingThreshold = 0f;
                        ModAPI.CreateParticleEffect("Spark", limb.gameObject.transform.position);
                        ModAPI.CreateParticleEffect("Spark", limb.gameObject.transform.position);
                        // ModAPI.CreateParticleEffect("Spark", limb.gameObject.transform.position);
                        other.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                        //ModAPI.CreateParticleEffect("Disintegration", ObjectWithPower.transform.position);

                    }
                    if (upgraded == true)
                    {
                        foreach (var i in other.transform.root.GetComponentsInChildren<LimbBehaviour>())
                        {
                            i.CirculationBehaviour.AddLiquid(Liquid.GetLiquid("???"), 1.4f);
                        }


                    }
                }





            }
        }
        public override void rev()
        {
            if (upgraded == false)
            {
                foreach (var i in ObjectWithPower.transform.root.GetComponentsInChildren<LimbBehaviour>())
                {
                    i.gameObject.GetComponent<LimbBehaviour>().BreakBone();
                    i.gameObject.GetComponent<LimbBehaviour>().Wince(20f);
                    i.gameObject.GetComponent<LimbBehaviour>().BreakingThreshold = 0f;
                    ModAPI.CreateParticleEffect("Spark", i.gameObject.transform.position);
                    Destroy(i.gameObject, 1);
                }

            }

        }




        private IEnumerator lechenie()
        {
            while (true)
            {
                Color newColor = new Color(
UnityEngine.Random.value,
UnityEngine.Random.value,
UnityEngine.Random.value,
0.20f

);
                while (this.gameObject.activeInHierarchy && ObjectGlow.GetComponent<SpriteRenderer>().color != newColor)
                {
                    ObjectGlow.GetComponent<SpriteRenderer>().color = Color.Lerp(ObjectGlow.GetComponent<SpriteRenderer>().color, newColor, Time.deltaTime * 10f);
                    yield return new WaitForEndOfFrame();
                }
                yield return new WaitForSeconds(time);
            }



        }



    }
    public class Firebeh : Powers
    {

        public override Color color1()
        {
            return new Color(0.88f, 0.34f, 0.13f);
        }
        public override string powerSpriteName()
        {
            return ("rukaudar");
        }
        public override string powerSpriteNameUpg()
        {
            return ("rukaudar1");
        }


        public void OnCollisionEnter2D(Collision2D other)
        {
            var rb = ObjectWithPower.GetComponent<Rigidbody2D>();

            if (ObjectWithPower.GetComponent<Rigidbody2D>().velocity.magnitude >= 2f && other.gameObject.GetComponent<Undraggable>() == null)
            {

                other.gameObject.GetComponent<PhysicalBehaviour>().Ignite();
                //other.gameObject.GetComponent<PhysicalBehaviour>().burnIntensity = 1f;
                other.gameObject.GetComponent<PhysicalBehaviour>().Temperature += 160f;
            }

            if (upgraded == true)
            {
                other.gameObject.GetComponent<PhysicalBehaviour>().Temperature += 1000f;
            }

        }


        public void FixedUpdate()
        {

            if (ObjectWithPower.GetComponent<Rigidbody2D>().velocity.magnitude >= 2f)
            {
                ObjectGlow.GetComponent<SpriteRenderer>().color = new Color(0.88f, 0.34f, 0.13f, Mathf.Clamp(gameObject.GetComponent<Rigidbody2D>().velocity.magnitude / 250f, 0f, 1f));
            }
            else
            {
                ObjectGlow.GetComponent<SpriteRenderer>().color = new Color(0f, 1f, 0f, 0f);
            }


        }




        public override void rev()
        {
            if (upgraded == false)
            {
                foreach (var i in ObjectWithPower.transform.root.GetComponentsInChildren<LimbBehaviour>())
                {
                    i.gameObject.GetComponent<PhysicalBehaviour>().Properties.Flammability = 1f;
                    i.gameObject.GetComponent<PhysicalBehaviour>().burnIntensity = 1f;
                    i.gameObject.GetComponent<PhysicalBehaviour>().Temperature += 1000f;
                    i.gameObject.GetComponent<LimbBehaviour>().Wince(20f);



                   

                }

            }

        }

    }
    public class Heal : Powers
    {

        public override Color color1()
        {
            return new Color(0.5f, 0.5f, 0.5f);
        }
        public override string powerSpriteName()
        {
            return ("Braslet2");
        }
        public override string powerSpriteNameUpg()
        {
            return ("Braslet2");
        }

        private BoxCollider2D bc;
        void Start()
        {
            bc = gameObject.AddComponent<BoxCollider2D>() as BoxCollider2D;
            bc.size = new Vector2(1.0f, 1.0f);
            bc.isTrigger = true;
            bc.transform.parent = ObjectWithPower.transform;
        }

        public void OnTriggerEnter2D(Collider2D other)
        {
            other.gameObject.TryGetComponent(out LimbBehaviour dr);

            if (dr != null && other.transform.root != this.transform.root)
            {
                ObjectGlow.GetComponent<SpriteRenderer>().color = new Color(0.5f, 0.5f, 0.5f, 0.25f);
                dr.HealBone();
                dr.Health = dr.InitialHealth;
                dr.Numbness = 0f;
                dr.CirculationBehaviour.HealBleeding();
                dr.CirculationBehaviour.IsPump = dr.CirculationBehaviour.WasInitiallyPumping;
                dr.CirculationBehaviour.BloodFlow = 5f;
                if (dr.CirculationBehaviour.GetAmount(dr.GetOriginalBloodType()) <= 1f)
                {
                    dr.CirculationBehaviour.AddLiquid(dr.GetOriginalBloodType(), 1.4f);
                }

                dr.BruiseCount = 0;
                dr.CirculationBehaviour.GunshotWoundCount = 0;
                dr.CirculationBehaviour.StabWoundCount = 0;

                dr.Person.Consciousness = 1f;
                dr.Person.ShockLevel = 0f;
                dr.Person.PainLevel = 0f;
                dr.Person.OxygenLevel = 1f;
                dr.Person.AdrenalineLevel = 1f;


                if (dr.PhysicalBehaviour.BurnProgress > 0.1f)
                {
                    dr.PhysicalBehaviour.BurnProgress -= 0.66f;
                }

                if (dr.SkinMaterialHandler.AcidProgress > 0.1f)
                {
                    dr.SkinMaterialHandler.AcidProgress -= 0.66f;
                }

                if (dr.SkinMaterialHandler.RottenProgress > 0.1f)
                {
                    dr.SkinMaterialHandler.RottenProgress -= 0.66f;
                }
                while ((double)((IEnumerable<Vector4>)dr.SkinMaterialHandler.damagePoints).Min<Vector4>((Func<Vector4, float>)(c => c.z)) < 50.0)
                {
                    for (int index = 0; index < dr.SkinMaterialHandler.damagePoints.Length; ++index)
                        dr.SkinMaterialHandler.damagePoints[index].z += 0.66f;
                    dr.SkinMaterialHandler.Sync();
                }
            }
            else
            {
                ObjectGlow.GetComponent<SpriteRenderer>().color = new Color(0.5f, 0.5f, 0.5f, 0f);
            }




        }


    }

    public class dualheal : Powers
    {

        public override Color color1()
        {
            return new Color(0f, 1f, 0f);
        }
        public override string powerSpriteName()
        {
            return ("puncho3");
        }
        public override string powerSpriteNameUpg()
        {
            return ("puncho");
        }


        public void OnCollisionEnter2D(Collision2D other)
        {
            var rb = ObjectWithPower.GetComponent<Rigidbody2D>();



            if (other.gameObject.GetComponent<LimbBehaviour>() != null && ObjectWithPower.GetComponent<Rigidbody2D>().velocity.magnitude >= 2f)
            {
                var dr = other.gameObject.GetComponent<LimbBehaviour>();
                dr.HealBone();
                dr.Health = dr.InitialHealth;
                dr.Numbness = 0f;
                dr.CirculationBehaviour.HealBleeding();
                dr.CirculationBehaviour.IsPump = dr.CirculationBehaviour.WasInitiallyPumping;
                dr.CirculationBehaviour.BloodFlow = 5f;
                if (dr.CirculationBehaviour.GetAmount(dr.GetOriginalBloodType()) <= 1f)
                {
                    dr.CirculationBehaviour.AddLiquid(dr.GetOriginalBloodType(), 1.4f);
                }
                dr.BruiseCount = 0;
                dr.CirculationBehaviour.GunshotWoundCount = 0;
                dr.CirculationBehaviour.StabWoundCount = 0;

                dr.Person.Consciousness = 1f;
                dr.Person.ShockLevel = 0f;
                dr.Person.PainLevel = 0f;
                dr.Person.OxygenLevel = 1f;
                dr.Person.AdrenalineLevel = 1f;
                dr.SkinMaterialHandler.RottenProgress = 0f;
                dr.SkinMaterialHandler.AcidProgress = 0f;
                dr.PhysicalBehaviour.BurnProgress = 0f;
            }



        }

        public void FixedUpdate()
        {

            if (ObjectWithPower.GetComponent<Rigidbody2D>().velocity.magnitude >= 2f)
            {
                ObjectGlow.GetComponent<SpriteRenderer>().color = new Color(0f, 1f, 0f, Mathf.Clamp(gameObject.GetComponent<Rigidbody2D>().velocity.magnitude / 250f, 0f, 1f));
            }
            else
            {
                ObjectGlow.GetComponent<SpriteRenderer>().color = new Color(0f, 1f, 0f, 0f);
            }
        }


    }

    public class dualkill : Powers
    {

        public override Color color1()
        {
            return new Color(1f, 0f, 0f);
        }
        public override string powerSpriteName()
        {
            return ("puncho3");
        }
        public override string powerSpriteNameUpg()
        {
            return ("puncho");
        }


        public void OnCollisionEnter2D(Collision2D other)
        {
            var rb = ObjectWithPower.GetComponent<Rigidbody2D>();



            if (other.gameObject.GetComponent<LimbBehaviour>() != null && ObjectWithPower.GetComponent<Rigidbody2D>().velocity.magnitude >= 2f)
            {
                var dr = other.gameObject.GetComponent<LimbBehaviour>();
                dr.Health = 0f;
            }



        }

        public void FixedUpdate()
        {


            if (ObjectWithPower.GetComponent<Rigidbody2D>().velocity.magnitude >= 2f)
            {
                ObjectGlow.GetComponent<SpriteRenderer>().color = new Color(1f, 0f, 0f, Mathf.Clamp(gameObject.GetComponent<Rigidbody2D>().velocity.magnitude / 250f, 0f, 1f));
            }
            else
            {
                ObjectGlow.GetComponent<SpriteRenderer>().color = new Color(0f, 1f, 0f, 0f);
            }


        }
        public override void rev()
        {


            foreach (var i in ObjectWithPower.transform.root.GetComponentsInChildren<LimbBehaviour>())
            {
                i.gameObject.GetComponent<LimbBehaviour>().Health = 0f;

            }

        }

    }









    class ExploPower : Powers
    {

        public override Color color1()
        {
            return new Color(0.7f, 0.1f, 0.1f);
        }
        public override string powerSpriteName()
        {
            return ("puncho3");
        }
        public override string powerSpriteNameUpg()
        {
            return ("puncho");
        }

        private List<ExpBoom> victims = new List<ExpBoom>();

        public void OnCollisionEnter2D(Collision2D other)
        {
            var rb = ObjectWithPower.GetComponent<Rigidbody2D>();


            if (rb.velocity.magnitude >= 3f)
            {
                var BRP = other.gameObject.transform.root.Find("Head").GetComponent<BodyRegenPassive>();
                if (other.gameObject.GetComponent<Undraggable>() == null && other.gameObject.GetComponent<ExpBoom>() == null && BRP == null || BRP.Resists.Contains(ResistData.ExplosiveResist) == false)
                {



                    var victim = other.gameObject.AddComponent<ExpBoom>();
                    victims.Add(victim);
                }
                if (upgraded == true)
                {
                    foreach (var i in other.transform.root.GetComponentsInChildren<LimbBehaviour>())
                    {
                        var victim = i.gameObject.AddComponent<ExpBoom>();
                        victims.Add(victim);
                    }
                }
            }
        }
        private void Use()
        {
            foreach (var boom in victims)
            {
                boom.BoomTrigger();
            }
            victims.Clear();
        }

        public override void rev()
        {
            if (upgraded == false)
            {
                ExplosionCreator.CreatePulseExplosion(transform.position, 0.1f, 0.1f, true, true);
                GameObject.Destroy(gameObject);
            }

        }
    }

    class ExpBoom : MonoBehaviour
    {
        void Awake()
        {
            this.gameObject.GetComponent<SpriteRenderer>().color = new Color(0.7f, 0.1f, 0.1f);
        }
        public void BoomTrigger()
        {
            ExplosionCreator.CreatePulseExplosion(transform.position, 0.1f, 0.1f, true, true);
            GameObject.Destroy(gameObject);
        }
    }





    public class ZeloVelocityPower : Powers
    {




        public override Color color1()
        {
            return new Color(0.8f, 0.5f, 0.2f);
        }

        public override string powerSpriteName()
        {
            return ("rukaudar");
        }
        public override string powerSpriteNameUpg()
        {
            return ("rukaudar1");
        }






        void Start()
        {
            BoxCollider2D bc;
            bc = gameObject.AddComponent<BoxCollider2D>() as BoxCollider2D;
            bc.size = new Vector2(3.0f, 3.0f);
            bc.isTrigger = true;
            bc.transform.parent = ObjectWithPower.transform;
        }


        public void OnTriggerEnter2D(Collider2D other)
        {
            var BRP = other.gameObject.transform.root.Find("Head").GetComponent<BodyRegenPassive>();
            if (other.gameObject.GetComponent<Undraggable>() == null && BRP == null || BRP.Resists.Contains(ResistData.ZeloVelocityResist) == false)
            {

                other.gameObject.GetComponent<Rigidbody2D>().velocity = Vector2.zero;
            }
            if (upgraded && other.gameObject.GetComponent<TimePoisonBehaviour>() == null && other.gameObject.GetComponent<BodyRegenPassive>().Resists.Contains(ResistData.ZeloVelocityResist) == false)
            {
                other.gameObject.AddComponent<TimePoisonBehaviour>();

            }





        }




        public override void rev()
        {
            if (upgraded == false)
            {
                foreach (var i in ObjectWithPower.transform.root.GetComponentsInChildren<LimbBehaviour>())
                {
                    ObjectWithPower.gameObject.AddComponent<TimePoisonBehaviour>();
                }




            }

        }





    }






    public class GunPower : Powers
    {


        public override Color color1()
        {
            return new Color(0.5f, 0.2f, 0.8f);
        }
        public override string powerSpriteName()
        {
            return null;
        }
        public override string powerSpriteNameUpg()
        {
            return null;
        }

        private GunBeh GunComp;
        public override void Awake()
        {
            base.Awake();
            GunComp = ObjectWithPower.AddComponent<GunBeh>();
        }

        public override void Nullificator()
        {
            if (upgraded == false)
            {
                GunComp.ObjectGlow.GetComponent<SpriteRenderer>().color = new Color(0f, 1f, 0f, 0f);
                
                Destroy(GunComp);
                Destroy(this);
            }

        }

        public override void rev()
        {
            if (upgraded == false)
            {
                ObjectWithPower.gameObject.GetComponent<PhysicalBehaviour>().charge = 60f;

            }

        }
        public override void upg()
        {
            if (GunComp.upgraded == false)
            {
                GunComp.upgraded = true;


                ModAPI.CreateParticleEffect("Spark", ObjectWithPower.transform.position);
            }
        }







    }





    public class GunBeh : CanShoot
    {

        private GameObject ObjectWithPower;
        private PhysicalBehaviour physicalBehaviour;
        public GameObject ObjectGlow;
        private Vector2 barrelPosition = new Vector2(0f, 0f);
        private Vector2 barrelDirection = new Vector2(0, -1);
        public bool upgraded = false;
        private LineRenderer beam;
        private LayerMask layers;
        private LayerMask bounds;
        private GameObject components;



        private RaycastHit2D[] victimBuffer = new RaycastHit2D[128];



        public void Start()
        {
            ObjectWithPower = gameObject;
            ObjectGlow = new GameObject();
            ObjectGlow.transform.parent = ObjectWithPower.transform;
            ObjectGlow.transform.localPosition = new Vector3(0f, 0f);
            ObjectGlow.transform.localScale = gameObject.transform.parent.localScale;
            ObjectGlow.transform.localRotation = Quaternion.identity;
            var RukaSprite = ObjectGlow.AddComponent<SpriteRenderer>();

            RukaSprite.sprite = powersprites.SpriteDictionary["GunArm.png"];
            RukaSprite.material = ModAPI.FindMaterial("VeryBright");
            RukaSprite.color = new Color(1f, 1f, 1f, 0.1f);
            RukaSprite.sortingLayerName = "Top";
            ObjectWithPower = gameObject;
            physicalBehaviour = GetComponent<PhysicalBehaviour>();

            layers = LayerMask.GetMask("Objects", "CollidingDebris", "Bounds");
            bounds = LayerMask.GetMask("Bounds");

            components = new GameObject("components", typeof(Optout));
            components.transform.SetParent(transform);
            components.transform.localPosition = new Vector3(0, 0);
            beam = components.AddComponent<LineRenderer>();
            beam.SetPositions(new[] { Vector3.zero, Vector3.right * 1000 });
            beam.useWorldSpace = false;
            beam.sharedMaterial = ModAPI.FindMaterial("VeryBright");
            beam.sortingLayerName = "Background";
            beam.startColor = Color.red;
            beam.endColor = Color.red;
            beam.widthMultiplier = 0.1f;
            beam.enabled = false;



        }
        private void Use()
        {
            Shoot();
        }


        public override void Shoot()
        {
            var pos = BarrelPosition;
            var dir = BarrelDirection;
            if (upgraded == false)
            {
                physicalBehaviour.rigidbody.AddForceAtPosition(dir * -2, pos, ForceMode2D.Impulse);
                var bolt = new GameObject("pellet", typeof(GunBehBolt));
                bolt.transform.position = pos;
                bolt.transform.right = dir;
                bolt.GetComponent<SpriteRenderer>().color = new Color(1f, 1f, 1f, 1f);
                CameraShakeBehaviour.main.Shake(.5f, pos);
            }
            else
            {
                StartCoroutine(Fire());

            }


        }




        private IEnumerator Fire()
        {
            const int iterations = 8;
            const float duration = 0.5f;

            const float interval = duration / iterations;

            beam.startColor = Color.magenta;
            beam.endColor = Color.magenta;
            beam.widthMultiplier = 0.1f;



            beam.enabled = true;
            for (int i = 0; i < iterations; i++)
            {
                var end = Physics2D.Raycast(BarrelPosition, BarrelDirection, 10000, bounds);
                var endPos = end.transform == null ? (Vector3)BarrelPosition + (Vector3)BarrelDirection * 10000 : (Vector3)end.point;
                var victimCount = Physics2D.LinecastNonAlloc(BarrelPosition, endPos, victimBuffer, layers);
                beam.SetPosition(1, components.transform.InverseTransformPoint(endPos));

                for (int n = 0; n < victimCount; n++)
                {
                    var victim = victimBuffer[n];
                    // if (victim.transform.gameObject.GetComponent<NoSleep7>().power != 3)
                    // {
                    ExplosionCreator.CreatePulseExplosion(victim.point, 0.5f, 1, true);
                    victim.transform.SendMessage("Break", BarrelDirection, SendMessageOptions.DontRequireReceiver);
                    victim.transform.SendMessage("Slice", SendMessageOptions.DontRequireReceiver);
                    //  }
                    // phys.rigidbody.AddForceAtPosition(forward * DirectionalForce * phys.rigidbody.mass, hit.point, ForceMode2D.Impulse);
                }

                CameraShakeBehaviour.main.Shake(2, transform.position);
                physicalBehaviour.rigidbody.AddRelativeForce(new Vector2(-0.1f * transform.localScale.normalized.x, 0), ForceMode2D.Impulse);
                yield return new WaitForSeconds(interval);
            }
            beam.enabled = false;
            yield return new WaitForSeconds(2.8f);
        }












        public override Vector2 BarrelPosition { get { return transform.TransformPoint(barrelPosition); } }

        public Vector2 BarrelDirection { get { return transform.TransformDirection(barrelDirection) * transform.localScale.x; } }


    }











    public class Shell : MonoBehaviour
    {
        public LimbBehaviour limb;

        GameObject ObjectWithPower;
        public void Start()
        {
            ObjectWithPower = gameObject;
            limb = ObjectWithPower.GetComponent<LimbBehaviour>();
            PhysicalBehaviour physicalBehaviour = limb.PhysicalBehaviour;
            StartCoroutine(lechenie(limb));



        }



        private IEnumerator lechenie(LimbBehaviour limb)
        {
            while (true)
            {
                limb.Person.Consciousness = 0f;
                foreach (var i in ObjectWithPower.transform.root.GetComponentsInChildren<LimbBehaviour>())
                {
                    limb.CirculationBehaviour.HealBleeding();

                }
                yield return new WaitForSeconds(0.2f);
            }





        }

        public void upg()
        {

            Destroy(this);


        }

    }

    public class ShellAwake : MonoBehaviour
    {
        Core core;
        ShellPunch sp1;
        ShellPunch sp2;
        private GameObject ObjectGlow;
        bool s = false;
        Texture2D texture;
        public GameObject ObjectWithPower;
        private BoxCollider2D bc;

        bool aura = false;

        public enum Level
        {
            zero,
            one,
            two
        }

        public enum PowerMode
        {

            Laser,
            Barrier,
            Punch,
            Soul

        }

        public PowerMode Mode;
        public Level Lvl;
        void Start()
        {
            Lvl = Level.zero;
            texture = powersprites.SpriteDictionary["it.png"].texture;
            ObjectWithPower = gameObject;




            core = this.transform.root.Find("Body").Find("MiddleBody").gameObject.GetComponent<Core>();

            sp1 = this.transform.root.Find("FrontArm").Find("LowerArmFront").GetComponent<ShellPunch>();
            sp2 = this.transform.root.Find("BackArm").Find("LowerArm").GetComponent<ShellPunch>();



            bc = gameObject.AddComponent<BoxCollider2D>() as BoxCollider2D;
            bc.size = new Vector2(4.0f, 4.0f);
            bc.isTrigger = true;
            bc.transform.parent = ObjectWithPower.transform;



            ObjectGlow = new GameObject();
            ObjectGlow.transform.parent = ObjectWithPower.transform;
            ObjectGlow.transform.localPosition = new Vector3(0f, 0f);
            ObjectGlow.transform.localRotation = Quaternion.identity;

            ObjectGlow.transform.localScale = new Vector3(1f, 1f);
            var RukaSprite = ObjectGlow.AddComponent<SpriteRenderer>();

            RukaSprite.sprite = powersprites.SpriteDictionary["mask1.png"];
            RukaSprite.material = ModAPI.FindMaterial("VeryBright");
            RukaSprite.color = new Color(1f, 1f, 1f, 0f);
            RukaSprite.sortingLayerName = "Top";
            ObjectGlow.transform.localRotation = Quaternion.identity;







        }
        void upg()
        {
            if (Lvl == Level.zero)
            {

                GetComponent<LimbBehaviour>().Person.SetBodyTextures(texture);
                GetComponent<LimbBehaviour>().Person.Consciousness = 1f;

                CreateContextMenuOptions();


                core.g();
                ModAPI.Notify("<color=#ffC0cb>Right click on the head to change the current ability</color>");


                foreach (var gameObj in FindObjectsOfType(typeof(soul)) as soul[])
                {
                    ModAPI.CreateParticleEffect("PinkExplosion", gameObj.transform.position);
                    Destroy(gameObj.gameObject);
                }

                Lvl = Level.one;

            }


        }

        private void Use()
        {
            switch (Mode)
            {
                case PowerMode.Barrier:

                    break;
                case PowerMode.Laser:
                    if (Lvl == Level.one)
                    {
                        ObjectWithPower.GetComponent<LazerEye>().Pew();
                    }
                    else
                    {
                        ObjectWithPower.GetComponent<GunBeh1>().Pew();
                    }


                    break;

            }
        }

        void RoundTwo()
        {
            foreach (var i in ObjectWithPower.transform.root.GetComponentsInChildren<SpriteRenderer>())
            {
                i.gameObject.AddComponent<ImmortalityBehaviour>();
                i.material = ModAPI.FindMaterial("VeryBright");


            }

            var items = Global.main.PhysicalObjectsInWorld.ToArray();



            Destroy(ObjectWithPower.GetComponent<LazerEye>());
            ObjectWithPower.AddComponent<GunBeh1>();

            sp1.ult = true;
            sp2.ult = true;


            ModAPI.CreateParticleEffect("HugeZap", ObjectWithPower.transform.position);
            ModAPI.CreateParticleEffect("PinkExplosion", ObjectWithPower.transform.position);
            ModAPI.CreateParticleEffect("Vapor", ObjectWithPower.transform.position);

            ObjectGlow.GetComponent<SpriteRenderer>().color = new Color(1f, 0.1f, 0.1f, 1f);

            for (int i = 0; i < Global.main.PhysicalObjectsInWorld.Count; i++)
            {

                items[i].GetComponent<PhysicalBehaviour>().SendMessage("OnEMPHit", SendMessageOptions.DontRequireReceiver);
                if (items[i].GetComponent<ImmortalityBehaviour>() == null)
                {
                    items[i].GetComponent<Rigidbody2D>().AddForceAtPosition(new Vector2(1f, 1f) * UnityEngine.Random.Range(-4, 4), items[i].transform.position, ForceMode2D.Impulse);
                }


            }



        }

        public void rev()
        {

            switch (Lvl)
            {
                case (Level.zero):

                    if (s == false)
                    {
                        s = true;
                        // ModAPI.Notify("<color=#425292>You have already caused enough pain in this world.");
                        // ModAPI.Notify("<color=#425292>Perish in the void.");
                        StartCoroutine(death(20f, false));
                    }


                    break;
                case (Level.one):
                    if (s == false)
                    {
                        s = true;




                        StartCoroutine(death(70f, true));

                    }
                    break;

                case (Level.two):
                    if (s == false)
                    {
                        s = true;
                        ModAPI.Notify("<color=#425292>I won't fail this time.");
                        var a = Instantiate(ModAPI.FindSpawnable("Decimator").Prefab.GetComponent<DecimatorBehaviour>().BlackHole, this.transform.position, Quaternion.identity);
                        a.GetComponent<SpriteRenderer>().color = Color.magenta;
                        a.GetComponent<SpriteRenderer>().material = ModAPI.FindMaterial("VeryBright");


                    }

                    break;


            }





        }

        private IEnumerator death(float speed, bool impulse)
        {
            Color fin = new Color(0f, 0f, 0f, 0f);


            foreach (var i in ObjectWithPower.transform.root.GetComponentsInChildren<SpriteRenderer>())
            {



                while (i.gameObject.activeInHierarchy && i.color != fin)
                {
                    i.color = Color.Lerp(i.color, fin, Time.deltaTime * speed);
                    yield return new WaitForEndOfFrame();
                }
                if (i.GetComponent<Collider2D>() != null)
                {
                    i.GetComponent<Collider2D>().enabled = false;
                }

            }
            if (impulse == true)
            {
                ModAPI.CreateParticleEffect("EnormousExplosion", ObjectWithPower.transform.position);
                ModAPI.CreateParticleEffect("PinkExplosion", ObjectWithPower.transform.position);
                var items = Global.main.PhysicalObjectsInWorld.ToArray();
                for (int i = 0; i < Global.main.PhysicalObjectsInWorld.Count; i++)
                {
                    items[i].GetComponent<Rigidbody2D>().AddForceAtPosition(new Vector2(1f, 1f) * UnityEngine.Random.Range(-10, 11), items[i].transform.position, ForceMode2D.Impulse);

                }
            }
            ModAPI.Notify("<color=#425292>Don't come back again.");
            Destroy(ObjectWithPower.transform.root.gameObject);
            yield return new WaitForEndOfFrame();

        }






        private void CreateContextMenuOptions()
        {
            var cont = this.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons;

            cont.Add(new ContextMenuButton("<color=#ffC0cb>Switch ability</color>", "<color=#ffC0cb>Switch ability</color>", "<color=#ffC0cb>Switch ability</color>", () =>
            {

                switch (Mode)
                {
                    case PowerMode.Laser:
                        Mode = PowerMode.Barrier;

                        core.setcolor(new Color(0.1f, 1f, 0.1f, 0.3f));
                        ModAPI.Notify("<color=#ffC0cb>Current Ability: Repulsive field</color>");
                        break;

                    case PowerMode.Barrier:

                        Mode = PowerMode.Punch;
                        core.setcolor(new Color(1f, 0.1f, 0.1f, 0.3f));

                        sp1.toggle();
                        sp2.toggle();
                        ModAPI.Notify("<color=#ffC0cb>Current Ability: Gravity punches</color>");
                        break;
                    case PowerMode.Punch:

                        Mode = PowerMode.Soul;
                        core.setcolor(new Color(1f, 1f, 1f, 0.3f));
                        sp1.toggle();
                        sp2.toggle();
                        aura = !aura;
                        ModAPI.Notify("<color=#ffC0cb>Current Ability: Soul strengthening aura</color>");
                        break;
                    case PowerMode.Soul:

                        Mode = PowerMode.Laser;
                        aura = !aura;
                        core.setcolor(new Color(0.7f, 0f, 0.7f, 0.3f));
                        ModAPI.Notify("<color=#ffC0cb>Current Ability: Activate head to shoot laser beam</color>");
                        break;





                }



            }));
        }



        public void OnTriggerEnter2D(Collider2D other)
        {
            var BRP = other.gameObject.transform.root.Find("Head").GetComponent<BodyRegenPassive>();

            if (Mode == PowerMode.Barrier && BRP == null || BRP.Resists.Contains(ResistData.BarrierResist) == false)
            {
                other.gameObject.GetComponent<Rigidbody2D>().AddForceAtPosition(other.gameObject.GetComponent<Rigidbody2D>().velocity * -2, other.transform.position, ForceMode2D.Impulse);

                if (other.gameObject.GetComponent<Rigidbody2D>().velocity.magnitude >= 0f & other.gameObject.GetComponent<Rigidbody2D>().velocity.magnitude <= 1)
                {
                    other.gameObject.GetComponent<LimbBehaviour>().Crush();

                }
                ModAPI.CreateParticleEffect("Vapor", ObjectWithPower.transform.position);


            }
            if (aura == true)
            {
                other.gameObject.SendMessage("upg", SendMessageOptions.DontRequireReceiver);
            }


        }
        private void Update()
        {
            if (!GetComponent<LimbBehaviour>().Person.IsAlive() && Lvl == Level.one)
            {
                Lvl = Level.two;
                RoundTwo();
            }

        }




    }



    class LazerEye : MonoBehaviour
    {
        LimbBehaviour Limb;









        void Awake()
        {
            Limb = gameObject.GetComponent<LimbBehaviour>();


        }

        public void Pew()
        {
            GameObject LaserObj = Instantiate(ModAPI.FindSpawnable("Blaster Rifle").Prefab.GetComponent<BlasterBehaviour>().Bolt);

            LaserObj.GetComponent<BlasterboltBehaviour>().damage = 200f;
            LaserObj.GetComponent<BlasterboltBehaviour>().TemperatureTarget = 9999f;
            LaserObj.GetComponent<BlasterboltBehaviour>().Trail.startWidth = 0.2f;
            LaserObj.GetComponent<BlasterboltBehaviour>().Trail.endWidth = 0.05f;
            LaserObj.GetComponent<BlasterboltBehaviour>().Trail.startColor = new Color(1f, 0f, 1f, 0.5f);
            LaserObj.GetComponent<BlasterboltBehaviour>().Trail.endColor = new Color(1f, 0f, 1f, 0.1f);


            ModAPI.CreateParticleEffect("Vapor", Limb.transform.position);
            LaserObj.transform.position = Limb.transform.position;
            if (Limb.Person.transform.localScale.x < 0)
                LaserObj.transform.eulerAngles = new Vector3(Limb.transform.eulerAngles.x, Limb.transform.eulerAngles.y, Limb.transform.eulerAngles.z + 180);
            else LaserObj.transform.eulerAngles = Limb.transform.eulerAngles;




        }







    }


    public class GunBeh1 : CanShoot
    {

        private GameObject ObjectWithPower;
        private PhysicalBehaviour physicalBehaviour;
        private Vector2 barrelPosition = new Vector2(0f, 0f);
        private Vector2 barrelDirection = new Vector2(6, -1);

        private LineRenderer beam;
        private LayerMask layers;
        private LayerMask bounds;
        private GameObject components;

        private bool ready;

        private RaycastHit2D[] victimBuffer = new RaycastHit2D[128];



        public void Start()
        {
            ObjectWithPower = gameObject;
            physicalBehaviour = GetComponent<PhysicalBehaviour>();

            layers = LayerMask.GetMask("Objects", "CollidingDebris", "Bounds");
            bounds = LayerMask.GetMask("Bounds");

            components = new GameObject("components", typeof(Optout));
            components.transform.SetParent(transform);
            components.transform.localPosition = new Vector3(0, 0);
            beam = components.AddComponent<LineRenderer>();
            beam.SetPositions(new[] { Vector3.zero, Vector3.right * 1000 });
            beam.useWorldSpace = false;
            beam.sharedMaterial = ModAPI.FindMaterial("VeryBright");
            beam.sortingLayerName = "Bottom";


            beam.enabled = false;

            ready = true;



        }
        public void Pew() => Shoot();


        public override void Shoot()
        {
            var pos = BarrelPosition;
            var dir = BarrelDirection;



            if (ready == true)
            {
                StartCoroutine(Fire());
            }







        }




        private IEnumerator Fire()
        {
            const int iterations = 8;
            const float duration = 0.5f;

            const float interval = duration / iterations;

            beam.startColor = Color.magenta;
            beam.endColor = Color.magenta;
            beam.widthMultiplier = 0.21f;



            ready = false;
            beam.enabled = true;
            for (int i = 0; i < iterations; i++)
            {
                var end = Physics2D.Raycast(BarrelPosition, BarrelDirection, 10000, bounds);
                var endPos = end.transform == null ? (Vector3)BarrelPosition + (Vector3)BarrelDirection * 10000 : (Vector3)end.point;
                var victimCount = Physics2D.LinecastNonAlloc(BarrelPosition, endPos, victimBuffer, layers);
                beam.SetPosition(1, components.transform.InverseTransformPoint(endPos));

                for (int n = 0; n < victimCount; n++)
                {
                    var victim = victimBuffer[n];

                    ExplosionCreator.CreatePulseExplosion(victim.point, 0.5f, 1, true);
                    if (!victim.transform.gameObject.TryGetComponent(out ImmortalityBehaviour imm))
                    {
                        victim.transform.SendMessage("Break", BarrelDirection, SendMessageOptions.DontRequireReceiver);
                        victim.transform.TryGetComponent(out PhysicalBehaviour ph);
                        ph.Temperature += 1000;
                        victim.transform.SendMessage("Slice", SendMessageOptions.DontRequireReceiver);
                    }


                }

                CameraShakeBehaviour.main.Shake(2, transform.position);
                physicalBehaviour.rigidbody.AddRelativeForce(new Vector2(-0.1f * transform.localScale.normalized.x, 0), ForceMode2D.Impulse);
                yield return new WaitForSeconds(interval);
            }
            beam.enabled = false;
            yield return new WaitForSeconds(0.6f);
            ready = true;
        }















        public override Vector2 BarrelPosition { get { return transform.TransformPoint(barrelPosition); } }

        public Vector2 BarrelDirection { get { return transform.TransformDirection(barrelDirection) * transform.localScale.x; } }


    }



    public class ShellPunch : MonoBehaviour
    {
        public GameObject ObjectWithPower;
        public GameObject ObjectGlow;

        public bool active = false;
        public bool ult = false;
        public void Awake()
        {

            ObjectWithPower = gameObject;

            ObjectGlow = new GameObject();
            ObjectGlow.transform.parent = ObjectWithPower.transform;
            ObjectGlow.transform.localPosition = new Vector3(0f, 0f);
            ObjectGlow.transform.localScale = gameObject.transform.parent.localScale;
            //ObjectGlow.transform.localRotation = ObjectWithPower.transform.localRotation;
            ObjectGlow.transform.localRotation = Quaternion.identity;
            var RukaSprite = ObjectGlow.AddComponent<SpriteRenderer>();



            RukaSprite.sprite = powersprites.SpriteDictionary["Brasletz.png"];

            RukaSprite.material = ModAPI.FindMaterial("VeryBright");
            RukaSprite.color = new Color(0f, 0f, 0f, 0f);
            RukaSprite.sortingLayerName = "Top";

        }

        public void toggle()
        {
            if (active == false)
            {
                ObjectGlow.GetComponent<SpriteRenderer>().color = new Color(1f, 1f, 1f, 0.05f);
                active = !active;
            }
            else
            {
                ObjectGlow.GetComponent<SpriteRenderer>().color = new Color(0f, 0f, 0f, 0f);
                active = !active;
            }

        }


        public void OnCollisionEnter2D(Collision2D other)
        {
            var rb = ObjectWithPower.GetComponent<Rigidbody2D>();
            if ((rb.velocity.magnitude >= 3f & other.gameObject.GetComponent<Undraggable>() == null) && active == true)
            {
                ModAPI.CreateParticleEffect("Vapor", ObjectWithPower.transform.position);
                other.gameObject.GetComponent<Rigidbody2D>().velocity = rb.velocity * 5;

                if (ult == true)
                {
                    other.gameObject.AddComponent<ShellMassAdd>();
                }
            }

        }







    }


    class ShellMassAdd : MonoBehaviour
    {
        Rigidbody2D rig;
        public void Start()
        {

            rig = this.gameObject.GetComponent<Rigidbody2D>();
            this.gameObject.GetComponent<SpriteRenderer>().color = Color.magenta;
            StartCoroutine(AddMass());
        }

        IEnumerator AddMass()
        {
            while (rig.mass <= 100f)
            {
                yield return new WaitForSeconds(0.2f);
                rig.mass += 5f;


            }

            this.gameObject.TryGetComponent(out LimbBehaviour limb);
            ModAPI.CreateParticleEffect("Vapor", limb.transform.position);
            yield return new WaitForSeconds(0.1f);
            limb.Crush();

        }

    }


    class Core : MonoBehaviour
    {
        GameObject ObjectWithPower;
        GameObject ObjectGlow;
        SpriteRenderer renderer;
        Color targetColor;
        Color oldcolor;
        float timeleft;
        void Awake()
        {
            ObjectWithPower = gameObject;
            renderer = ObjectWithPower.GetComponent<SpriteRenderer>();
            ObjectGlow = new GameObject();
            ObjectGlow.transform.parent = ObjectWithPower.transform;
            ObjectGlow.transform.localPosition = new Vector3(0f, 0f);
            ObjectGlow.transform.localScale = gameObject.transform.parent.localScale;
            ObjectGlow.transform.localRotation = Quaternion.identity;
            var RukaSprite = ObjectGlow.AddComponent<SpriteRenderer>();



            RukaSprite.sprite = ModAPI.LoadSprite("textures/Core.png");
            RukaSprite.material = ModAPI.FindMaterial("VeryBright");
            RukaSprite.color = new Color(1f, 0f, 1f, 0);
            RukaSprite.sortingLayerName = "Bottom";
        }

        public void g()
        {
            ObjectGlow.GetComponent<SpriteRenderer>().color = new Color(1f, 0f, 1f, 0.3f);

        }

        public void setcolor(Color color1)
        {
            ObjectGlow.GetComponent<SpriteRenderer>().color = color1;
        }

    }





    class bite : MonoBehaviour
    {

        private RaycastHit2D[] ray = new RaycastHit2D[1];



        private bool H()
        {
            var end = Physics2D.Raycast(gameObject.transform.position, transform.root.localScale, 10, LayerMask.GetMask("Objects", "CollidingDebris", "Bounds"));
            var endPos = end.transform == null ? (Vector3)gameObject.transform.position + (Vector3)transform.root.localScale * 10 : (Vector3)end.point;
            var victimCount = Physics2D.LinecastNonAlloc(gameObject.transform.position, endPos, ray, LayerMask.GetMask("Objects", "CollidingDebris", "Bounds"));
            if (victimCount == 0)
            {
                return false;
            }
            return true;

        }

        public void OnCollisionEnter2D(Collision2D other)
        {
            var BRP = other.gameObject.transform.root.Find("Head").GetComponent<BodyRegenPassive>();
            other.gameObject.TryGetComponent(out LimbBehaviour limb);
            if (limb.IsZombie == false && BRP == null || BRP.Resists.Contains(ResistData.ZombieBiteResist) == false)
            {
                if (H())
                {
                    DistanceJoint2D joint = gameObject.AddComponent<DistanceJoint2D>();
                    joint.maxDistanceOnly = false;
                    joint.enableCollision = true;
                    joint.distance = 0.1f;
                    joint.autoConfigureDistance = true;
                    joint.breakForce = 15f;
                    joint.breakTorque = 15f;
                    joint.anchor = new Vector2(0f, 0f);
                    joint.connectedAnchor = new Vector2(0f, 0f);
                    joint.connectedBody = other.gameObject.GetComponent<Rigidbody2D>();

                    RigidWireBehaviour wire = joint.gameObject.AddComponent<RigidWireBehaviour>();
                    wire.WireWidth = 0f;
                    wire.typedJoint = joint;
                    other.gameObject.GetComponent<LimbBehaviour>().CirculationBehaviour.AddLiquid(Liquid.GetLiquid("REANIMATION AGENT"), 1f);
                    other.gameObject.transform.root.Find("Head").gameObject.AddComponent<bite>();
                    ModAPI.CreateParticleEffect("BloodExplosion", gameObject.transform.position);
                }
            }




        }

        private void Nullificator()
        {
            Destroy(this);
        }


    }

    class voidtouch : Powers
    {
        bool said = false;
        bool said2 = false;
        bool said3 = false;


        public enum PowerMode
        {

            Transformation,
            Punch


        }

        public PowerMode Mode = PowerMode.Transformation;


        AudioSource audio;
        AudioClip clip;

        public override string powerSpriteName()
        {
            return ("Braslet44");
        }
        public override string powerSpriteNameUpg()
        {
            return ("Braslet44");
        }

        public override Color color1()
        {
            return new Color(1f, 1f, 1f, 0.1f);
        }

        private List<Sprite> voids = new List<Sprite>();


        public override void Awake()
        {
            base.Awake();
            audio = ObjectWithPower.AddComponent<AudioSource>();
            audio.volume = 2.3f;
            clip = ModAPI.LoadSound("123.wav");

            voids.Add(powersprites.SpriteDictionary["void1.png"]);
            voids.Add(powersprites.SpriteDictionary["void2.png"]);
            voids.Add(powersprites.SpriteDictionary["void3.png"]);
            voids.Add(powersprites.SpriteDictionary["void4.png"]);
        }


        public void OnCollisionEnter2D(Collision2D other)
        {
            var BRP = other.gameObject.transform.root.Find("Head").GetComponent<BodyRegenPassive>();
            if (Mode == PowerMode.Transformation)
            {

                other.gameObject.transform.root.Find("Head").TryGetComponent(out LimbBehaviour limb);
                if (limb != null && other.gameObject.transform.root.Find("Head").gameObject.GetComponent<voidhead>() == null && BRP == null || BRP.Resists.Contains(ResistData.VoidTransformResist) == false)
                {
                    limb.Person.SetBodyTextures(voids.PickRandom().texture);
                    other.gameObject.transform.root.Find("Head").gameObject.AddComponent<voidhead>();
                    return;
                }
            }
            else
            {
                other.gameObject.transform.root.Find("Head").TryGetComponent(out PhysicalBehaviour phys);
                if (phys != null && BRP == null || BRP.Resists.Contains(ResistData.VoidTransformResist) == false)
                {
                    phys.Disintegrate();
                    ModAPI.CreateParticleEffect("Disintegration", other.gameObject.transform.position);
                }
            }

            if (other.gameObject.GetComponent<Core>() || other.gameObject.GetComponent<ShellAwake>())
            {
                ModAPI.Notify("<color=#ffC0cb>...</color>");
                foreach (var i in gameObject.transform.root.GetComponentsInChildren<LimbBehaviour>())
                {
                    ModAPI.CreateParticleEffect("Spark", i.gameObject.transform.position);
                    i.Crush();
                }
            }
        }

        public void Nullificatr()
        {
            if (said2 == false)
            {
                said2 = true;
                audio.PlayOneShot(clip, 1.5f);
                ModAPI.Notify("<color=#5e5e5e>What have you done to me?</color>");
            }

        }

        public void FixedUpdate()
        {


            if (gameObject.GetComponent<Rigidbody2D>().velocity.magnitude >= 3f)
            {
                ObjectGlow.GetComponent<SpriteRenderer>().color = new Color(1f, 1f, 1f, Mathf.Clamp(gameObject.GetComponent<Rigidbody2D>().velocity.magnitude / 250f, 0f, 1f));
            }
            else
            {
                ObjectGlow.GetComponent<SpriteRenderer>().color = new Color(1f, 1f, 1f, 0f);
            }


        }

        public override void Nullificator()
        {
            if (said == false)
            {
                said = true;
                StartCoroutine(no());
            }

        }
        IEnumerator no()
        {
            audio.PlayOneShot(clip);
            ModAPI.Notify("<color=#5e5e5e>What happened?</color>");
            yield return new WaitForSeconds(1f);
            audio.PlayOneShot(clip);
            ModAPI.Notify("<color=#5e5e5e>That feeling</color>");
            yield return new WaitForSeconds(2f);
            audio.PlayOneShot(clip);
            ModAPI.Notify("<color=#5e5e5e>It's like a piece of me has been ripped off</color>");
            yield return new WaitForSeconds(2f);
            audio.PlayOneShot(clip);
            ModAPI.Notify("<color=#5e5e5e>I can resist it! I am not so easy to defeat!</color>");

        }
        public override void upg()
        {
            if (upgraded == false)
            {
                upgraded = true;
                StartCoroutine(u());
            }

        }

        public override void rev()
        {
            if (said3 == false)
            {
                said3 = true;
                StartCoroutine(k());
            }
        }
        public void Use() => sabil();


        void sabil()
        {
            switch (Mode)
            {
                case PowerMode.Punch:
                    Mode = PowerMode.Transformation;
                    ObjectGlow.GetComponent<SpriteRenderer>().sprite = powersprites.SpriteDictionary["Braslet44.png"];
                    break;
                case PowerMode.Transformation:
                    Mode = PowerMode.Punch;
                    ObjectGlow.GetComponent<SpriteRenderer>().sprite = powersprites.SpriteDictionary["Braslet45.png"];
                    break;
            }



        }
        private IEnumerator k()
        {
            foreach (var i in gameObject.transform.root.GetComponentsInChildren<LimbBehaviour>())
            {
                ModAPI.CreateParticleEffect("Flash", i.gameObject.transform.position);
            }

            audio.PlayOneShot(clip);
            ModAPI.Notify("<color=#5e5e5e>What a fool I've been!</color>");
            yield return new WaitForSeconds(3f);
            audio.PlayOneShot(clip);
            ModAPI.Notify("<color=#5e5e5e>I gave you</color> <color=#ffC0cb>its </color><color=#5e5e5e>location, got you out of the void, and this is how you repay me?</color>");
            yield return new WaitForSeconds(7f);
            audio.PlayOneShot(clip);
            ModAPI.Notify("<color=#5e5e5e>Even if you can handle the </color><color=#ffC0cb>Shell</color><color=#5e5e5e>, it won't change anything.</color>");
            yield return new WaitForSeconds(7f);
            audio.PlayOneShot(clip, 1f);
            ModAPI.Notify("<color=#5e5e5e>Looks like my time is running out.</color>");
            yield return new WaitForSeconds(7f);

            audio.PlayOneShot(clip, 2f);
            ModAPI.Notify("<color=#5e5e5e>See you in hell</color>");
            yield return new WaitForSeconds(3f);
            foreach (var i in gameObject.transform.root.GetComponentsInChildren<LimbBehaviour>())
            {
                ModAPI.CreateParticleEffect("Disintegration", i.gameObject.transform.position);
                i.Crush();
            }



        }

        IEnumerator u()
        {
            audio.PlayOneShot(clip);
            ModAPI.Notify("<color=#5e5e5e>After what I did, am I still worthy of this gift?</color>");
            yield return new WaitForSeconds(2f);
            foreach (var i in gameObject.transform.root.GetComponentsInChildren<LimbBehaviour>())
            {
                i.Wince(20f);
                i.BaseStrength = 0.1f;
                i.SendMessage("Nullificatr", SendMessageOptions.DontRequireReceiver);
                ModAPI.CreateParticleEffect("Spark", i.gameObject.transform.position);
                i.CirculationBehaviour.BleedingRate += 1.5f;

                i.CirculationBehaviour.CreateBleedingParticle(i.transform.position + new Vector3(0.05f, -0.05f) * UnityEngine.Random.Range(0.97f, 1.02f), UnityEngine.Random.insideUnitCircle * UnityEngine.Random.Range(-0.4f, 0.4f));

            }
            yield return new WaitForSeconds(5f);
            audio.PlayOneShot(clip, 2.3f);
            ModAPI.Notify("<color=#5e5e5e>My </color><color=#ffC0cb>Lord</color><color=#5e5e5e> have mercy.");
            yield return new WaitForSeconds(1f);
            audio.PlayOneShot(clip, 2f);
            ModAPI.Notify("<color=#5e5e5e>I am willing to do anything for your forgiveness");
            yield return new WaitForSeconds(4f);
            foreach (var i in gameObject.transform.root.GetComponentsInChildren<LimbBehaviour>())
            {
                i.Crush();

            }




        }
    }
    class voidhead : MonoBehaviour
    {
        public void Awake()
        {



            foreach (var i in gameObject.transform.root.GetComponentsInChildren<LimbBehaviour>())
            {
                i.Vitality = 1.5f;
                i.Health = 1.5f;
                i.InitialHealth = 1.5f;
                i.Numbness = 1f;
                i.RegenerationSpeed = 1f;
                i.SendMessage("Nullificator", SendMessageOptions.DontRequireReceiver);
                i.Wince(20f);
            }


        }









        public void rev()
        {
            foreach (var i in gameObject.transform.root.GetComponentsInChildren<LimbBehaviour>())
            {
                ModAPI.CreateParticleEffect("Disintegration", i.gameObject.transform.position);
                i.PhysicalBehaviour.Disintegrate();
            }
        }

        private void upg()
        {

            gameObject.GetComponent<LimbBehaviour>().Crush();
        }


    }




    class fakevoidtouch : Powers
    {
        public enum PowerMode
        {

            Transformation,
            Punch


        }

        public PowerMode Mode = PowerMode.Transformation;


        public override string powerSpriteName()
        {
            return ("Braslet44");
        }
        public override string powerSpriteNameUpg()
        {
            return ("Braslet44");
        }

        public override Color color1()
        {
            return new Color(1f, 1f, 1f, 0.1f);
        }


        public void Use() => sabil();



        private List<Sprite> voids = new List<Sprite>();


        public override void Awake()
        {
            base.Awake();

            voids.Add(powersprites.SpriteDictionary["void1.png"]);
            voids.Add(powersprites.SpriteDictionary["void2.png"]);
            voids.Add(powersprites.SpriteDictionary["void3.png"]);
            voids.Add(powersprites.SpriteDictionary["void4.png"]);
        }




        void sabil()
        {
            switch (Mode)
            {
                case PowerMode.Punch:
                    Mode = PowerMode.Transformation;
                    Mode = PowerMode.Transformation;
                    ObjectGlow.GetComponent<SpriteRenderer>().sprite = powersprites.SpriteDictionary["Braslet44.png"];
                    break;
                case PowerMode.Transformation:
                    Mode = PowerMode.Punch;
                    ObjectGlow.GetComponent<SpriteRenderer>().sprite = powersprites.SpriteDictionary["Braslet45.png"];
                    break;
            }
        }
        public void OnCollisionEnter2D(Collision2D other)
        {
            var BRP = other.gameObject.transform.root.Find("Head").GetComponent<BodyRegenPassive>();
            if (Mode == PowerMode.Transformation)
            {

                other.gameObject.transform.root.Find("Head").TryGetComponent(out LimbBehaviour limb);
                if (limb != null && other.gameObject.transform.root.Find("Head").gameObject.GetComponent<voidhead>() == null && BRP == null || BRP.Resists.Contains(ResistData.VoidTransformResist) == false)
                {
                    limb.Person.SetBodyTextures(voids.PickRandom().texture);
                    other.gameObject.transform.root.Find("Head").gameObject.AddComponent<voidhead>();
                    return;
                }
            }
            else
            {
                other.gameObject.transform.root.Find("Head").TryGetComponent(out PhysicalBehaviour phys);
                if (BRP.Resists.Contains(ResistData.VoidTransformResist) == false && phys != null)
                {
                    phys.Disintegrate();
                    ModAPI.CreateParticleEffect("Disintegration", other.gameObject.transform.position);
                }
            }

            if (other.gameObject.GetComponent<Core>() || other.gameObject.GetComponent<ShellAwake>())
            {
                ModAPI.Notify("<color=#ffC0cb>...</color>");
                foreach (var i in gameObject.transform.root.GetComponentsInChildren<LimbBehaviour>())
                {
                    ModAPI.CreateParticleEffect("Spark", i.gameObject.transform.position);
                    i.Crush();
                }
            }
        }
        public override void upg()
        {

            gameObject.GetComponent<LimbBehaviour>().Crush();
        }
        public override void rev()
        {
            foreach (var i in gameObject.transform.root.GetComponentsInChildren<LimbBehaviour>())
            {
                ModAPI.CreateParticleEffect("Disintegration", i.gameObject.transform.position);
                i.PhysicalBehaviour.Disintegrate();
            }
        }
    }


    public class SwitchPlaces : Powers
    {

        public override string powerSpriteName()
        {
            return null;
        }
        public override string powerSpriteNameUpg()
        {
            return null;
        }

        public override Color color1()
        {
            return new Color(0.5f, 0.1f, 0.1f, 1f);
        }

        public override void Awake()
        {
            base.Awake();
            IsHeadPower = true;
        }


        Vector2 oldpos;
        GameObject victim;
        RaycastHit2D hit2D;
        public void Use()
        {
            if (GetComponent<LimbBehaviour>().Person.transform.localScale.x > 0)
            {
                hit2D = Physics2D.Raycast(transform.position, transform.right, 500);
            }
            else
            {
                hit2D = Physics2D.Raycast(transform.position, -transform.right, 500);
            }

            if (hit2D) {
                if (hit2D.transform.gameObject.GetComponent<LimbBehaviour>() != null)
                {
                    ModAPI.CreateParticleEffect("HugeZap", transform.position);
                    ModAPI.CreateParticleEffect("HugeZap", hit2D.transform.position);
                    oldpos = this.gameObject.GetComponent<LimbBehaviour>().Person.transform.position;
                    this.gameObject.GetComponent<LimbBehaviour>().Person.transform.position = hit2D.transform.gameObject.GetComponent<LimbBehaviour>().Person.transform.position;
                    hit2D.transform.gameObject.GetComponent<LimbBehaviour>().Person.transform.position = oldpos;

                    if (upgraded == true)
                    {
                        hit2D.transform.root.Find("Head").GetComponent<LimbBehaviour>().BreakBone();
                    }
                }
            }
        }



        public override void rev()
        {

            this.gameObject.GetComponent<LimbBehaviour>().Health = 0f;
            this.gameObject.GetComponent<LimbBehaviour>().BreakBone();



        }


    }





    public class RottenGodAura : Powers
    {

        public override string powerSpriteName()
        {
            return null;
        }
        public override string powerSpriteNameUpg()
        {
            return null;
        }





        public override Color color1()
        {
            return new Color(1f, 1f, 1f, 1f);
        }


        private GameObject halo;

        private BoxCollider2D bc;

        private float upgVal = 0f;
        public override void Nullificator()
        {
            if (upgraded == false)
            {
                Destroy(halo);
                Destroy(this);

            }

        }



        public override void Awake()
        {
            base.Awake();
            IsHeadPower = true;

            halo = new GameObject();
            halo.transform.parent = ObjectWithPower.transform;
            halo.transform.localPosition = new Vector3(0f, 0f);

            halo.transform.localScale = new Vector2(gameObject.transform.root.localScale.x, gameObject.transform.parent.localScale.y);
            halo.transform.localRotation = Quaternion.identity;
            var eyeSprite = halo.AddComponent<SpriteRenderer>();

            eyeSprite.sprite = powersprites.SpriteDictionary["BrokenHalo.png"];
            eyeSprite.material = ModAPI.FindMaterial("VeryBright");
            eyeSprite.color = new Color(0.6f, 0.6f, 0.6f, 0.25f);
            eyeSprite.sortingLayerName = "Top";






            bc = gameObject.AddComponent<BoxCollider2D>() as BoxCollider2D;
            bc.size = new Vector2(4.0f, 4.0f);
            bc.isTrigger = true;
            bc.transform.parent = ObjectWithPower.transform;



        }

        public void OnTriggerStay2D(Collider2D other)
        {

            var BRP = other.gameObject.transform.root.Find("Head").GetComponent<BodyRegenPassive>();
            if (other.transform.root != this.transform.root)
            {
                if(other.gameObject.GetComponent<LimbBehaviour>() != null && BRP == null || BRP.Resists.Contains(ResistData.RottenGodResist) == false)
                {
                    other.gameObject.GetComponent<PhysicalBehaviour>().BurnProgress += (0.25f + upgVal) * Time.deltaTime;

                    other.gameObject.GetComponent<LimbBehaviour>().Wince(5f);
                }


            }


        }
        public override void upg()
        {
            if (upgraded == false)
            {

                upgraded = true;
                upgVal = 0.45f;
                halo.GetComponent<SpriteRenderer>().sprite = powersprites.SpriteDictionary["glazaprost1.png"];
    
                
                bc.size = new Vector2(12.0f, 12.0f);
                ObjectGlow.GetComponent<SpriteRenderer>().color = new Color(0.8f, 0.8f, 0.8f, 0.2f);
                ModAPI.CreateParticleEffect("HugeZap", ObjectWithPower.transform.position);



            }
        }
        public override void rev()
        {
            if (upgraded == false)
            {

                foreach (var i in ObjectWithPower.transform.root.GetComponentsInChildren<LimbBehaviour>())
                {
                    i.gameObject.SendMessage("Nullificator", SendMessageOptions.DontRequireReceiver);
                }
                ObjectWithPower.gameObject.GetComponent<LimbBehaviour>().Crush();
            }

        }



    }


    public class SleepAura : Powers
    {


        public override string powerSpriteName()
        {
            return null;
        }
        public override string powerSpriteNameUpg()
        {
            return null;
        }

        public override Color color1()
        {
            return new Color(1f, 1f, 1f, 0.3f);
        }


        public void Use()
        {
 
                
                Collider2D[] colliders = Physics2D.OverlapCircleAll(transform.position, 3);

               
                foreach (var item in colliders)
                {
                   
                    if (item.GetComponent<LimbBehaviour>() && item.transform.root != this.transform.root)
                    {

                    if(item.gameObject.transform.root.Find("Head").gameObject.GetComponent<LimbBehaviour>() != null)
                    {
                        ModAPI.CreateParticleEffect("Vapor", item.gameObject.transform.root.Find("Head").transform.position);
                    }
                     
                  


                      item.GetComponent<LimbBehaviour>().Person.Consciousness = 0f;
                    if (upgraded == true)
                    {
                        var BRP = item.gameObject.transform.root.Find("Head").GetComponent<BodyRegenPassive>();
                        var rand = UnityEngine.Random.Range(0, 4);
                        if(rand == 2 && BRP == null || BRP.Resists.Contains(ResistData.CrusherResist) == false)
                        {
                            ModAPI.CreateParticleEffect("Vapor", item.transform.position);

                          item.GetComponent<LimbBehaviour>().Crush();
                        }
                        else
                        {
                            item.GetComponent<LimbBehaviour>().Person.Braindead = true;
                        }
                        
                    }

                    }
                }
            
        }

        public override void rev()
        {
            if (upgraded == false)
            {

                ObjectWithPower.gameObject.GetComponent<LimbBehaviour>().Crush();
            }

        }


    }



        public class GravityAura : Powers
    {


        public override string powerSpriteName()
        {
            return null;
        }
        public override string powerSpriteNameUpg()
        {
            return null;
        }




        public override Color color1()
        {
            return new Color(1f, 1f, 1f, 1f);
        }

        public override void Awake()
        {
            base.Awake();
            IsHeadPower = true;
            BoxCollider2D bc;
            bc = gameObject.AddComponent<BoxCollider2D>() as BoxCollider2D;
            bc.size = new Vector2(7.0f, 7.0f);
            bc.isTrigger = true;
            bc.transform.parent = ObjectWithPower.transform;
        }

        public void OnTriggerEnter2D(Collider2D other)
        {
            var BRP = other.gameObject.transform.root.Find("Head").GetComponent<BodyRegenPassive>();
            if (other.transform.root != this.transform.root && BRP == null || BRP.Resists.Contains(ResistData.CrusherResist) == false)
            {
                other.gameObject.GetComponent<Rigidbody2D>().velocity = other.gameObject.GetComponent<Rigidbody2D>().velocity * -5;
                if (other.gameObject.GetComponent<Rigidbody2D>().velocity.magnitude >= 0f & other.gameObject.GetComponent<Rigidbody2D>().velocity.magnitude <= 1)
                {
                    other.gameObject.GetComponent<LimbBehaviour>().Crush();

                }
                if (upgraded == true)
                {

                    other.gameObject.GetComponent<Rigidbody2D>().mass = 20f;

                }
            }




        }

        public override void rev()
        {
            if (upgraded == false)
            {

                foreach (var i in ObjectWithPower.transform.root.GetComponentsInChildren<LimbBehaviour>())
                {
                    i.gameObject.GetComponent<PhysicalBehaviour>().MakeWeightful();
                    i.gameObject.SendMessage("Nullificator", SendMessageOptions.DontRequireReceiver);
                }
                ObjectWithPower.gameObject.GetComponent<LimbBehaviour>().Crush();
            }

        }


        public override void upg()
        {
            if (upgraded == false)
            {
                upgraded = true;
                foreach (var i in ObjectWithPower.transform.root.GetComponentsInChildren<PhysicalBehaviour>())
                {
                    i.gameObject.AddComponent<ImmortalityBehaviour>();
                }
                ObjectGlow.GetComponent<SpriteRenderer>().sprite = powersprites.SpriteDictionary["forgottenone1.png"];
                ObjectGlow.GetComponent<SpriteRenderer>().color = new Color(0.9f, 0.9f, 0.9f, 0.1f);
                ModAPI.CreateParticleEffect("HugeZap", ObjectWithPower.transform.position);









            }
        }


    }
    public class BleedAura : Powers
    {




        public override string powerSpriteName()
        {
            return null;
        }
        public override string powerSpriteNameUpg()
        {
            return null;
        }




        public override Color color1()
        {
            return new Color(1f, 1f, 1f, 1f);
        }

        public override void Awake()
        {
            base.Awake();
            IsHeadPower = true;


            BoxCollider2D bc;
            bc = gameObject.AddComponent<BoxCollider2D>() as BoxCollider2D;
            bc.size = new Vector2(7.0f, 7.0f);
            bc.isTrigger = true;
            bc.transform.parent = ObjectWithPower.transform;

 

        }

        public void OnTriggerStay2D(Collider2D other)
        {
            var BRP = other.gameObject.transform.root.Find("Head").GetComponent<BodyRegenPassive>();
            if (other.transform.root != this.transform.root && other.gameObject.GetComponent<LimbBehaviour>() != null && BRP == null || BRP.Resists.Contains(ResistData.BleedResist) == false)
            {
                other.gameObject.GetComponent<LimbBehaviour>().CirculationBehaviour.BleedingRate += 0.002f;

                other.gameObject.GetComponent<LimbBehaviour>().Wince(2f);

            }



        }





        public override void rev()
        {
            ObjectWithPower.gameObject.GetComponent<LimbBehaviour>().CirculationBehaviour.BleedingRate += 5f;
        }


    }



    public class EmpAgent : Powers
    {


        public override string powerSpriteName()
        {
            return null;
        }
        public override string powerSpriteNameUpg()
        {
            return null;
        }

        public override Color color1()
        {
            return new Color(1f, 1f, 1f,0.3f);
        }




        private GameObject Ruka;

        private GameObject RukaGlow;

        public override void Awake()
        {
            Ruka = gameObject;



            BoxCollider2D bc;
            bc = gameObject.AddComponent<BoxCollider2D>() as BoxCollider2D;
            bc.size = new Vector2(4.0f, 4.0f);
            bc.isTrigger = true;
            bc.transform.parent = Ruka.transform;
        }

        public void OnTriggerEnter2D(Collider2D other)
        {
            other.gameObject.GetComponent<PhysicalBehaviour>().SendMessage("OnEMPHit", SendMessageOptions.DontRequireReceiver);


        }
        public override void rev()
        {


            Ruka.gameObject.GetComponent<PhysicalBehaviour>().charge = 40f;


        }




    }

    public class EnemyPower : Powers
    {

        public override Color color1()
        {
            return new Color(0.7f, 0.4f, 0.4f, 0.25f);
        }

        public override string powerSpriteName()
        {
            return ("Braslet");
        }
        public override string powerSpriteNameUpg()
        {
            return ("Braslet");
        }






        private bool IsAbrorbing = true;


        private Powers CurrentPower;





        public override void Awake()
        {
            base.Awake();


            CreateContextMenuOptions();



        }
        public override void upg()
        {
            if (upgraded == false)
            {

                // ModAPI.CreateParticleEffect("HugeZap", ObjectWithPower.transform.position);
            }
        }

        public void OnCollisionEnter2D(Collision2D other)
        {
            var rb = ObjectWithPower.GetComponent<Rigidbody2D>();
            var dr = other.gameObject;

            if (ObjectWithPower.GetComponent<Rigidbody2D>().velocity.magnitude >= 2f)
            {

                if (IsAbrorbing)
                {
                    absorb(other.gameObject);
                }







            }





        }

        public override void rev()
        {
            if (upgraded == false)
            {

                ObjectWithPower.gameObject.GetComponent<LimbBehaviour>().Crush();
            }

        }
        private void CreateContextMenuOptions()
        {
            this.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("Absorb", "Change power to Absorb mode", "Change power to Absorb mode", () =>
            {
                IsAbrorbing = true;
                CurrentPower.Nullificator();
                ObjectGlow.GetComponent<SpriteRenderer>().color = new Color(0.7f, 0.4f, 0.4f, 0.25f);

            }));
        }




        private void absorb(GameObject victim)
        {
            if (victim.GetComponent<LimbBehaviour>() != null && victim.gameObject.transform.root.Find("Head").GetComponent<BodyRegenPassive>() == null || victim.gameObject.transform.root.Find("Head").GetComponent<BodyRegenPassive>().Resists.Contains(ResistData.CrusherResist) == false)
            {
                if (victim.GetComponent<Powers>() != null)
                {
                    IsAbrorbing = false;
                    var newpower = victim.GetComponent<Powers>().GetType();
                    CurrentPower = ObjectWithPower.AddComponent(newpower) as Powers;
                    ObjectGlow.GetComponent<SpriteRenderer>().color = CurrentPower.color1();
                    CurrentPower.ObjectGlow.transform.localScale = Vector3.zero;
                }
                victim.GetComponent<LimbBehaviour>().Crush();

            }

        }



    }


    public class PowerGive : Powers
    {

        public override Color color1()
        {
            return new Color(0.2f, 0.9f, 0.7f, 0.15f);
        }
        public override string powerSpriteName()
        {
            return ("Braslet");
        }
        public override string powerSpriteNameUpg()
        {
            return ("Braslet");
        }






        public void OnCollisionEnter2D(Collision2D other)
        {
            var rb = ObjectWithPower.GetComponent<Rigidbody2D>();



            foreach (var i in other.transform.root.GetComponentsInChildren<LimbBehaviour>())
            {

                Meishu.ApplyRandAbility(other.gameObject);
            }



        }
    









        public override void rev()
        {
            if (upgraded == false)
            {
                ObjectWithPower.GetComponent<LimbBehaviour>().Crush();

            }

        }




    }



    public class ReplicatorAura : Powers
    {

        public override string powerSpriteName()
        {
            return null;
        }
        public override string powerSpriteNameUpg()
        {
            return null;
        }


        public override Color color1()
        {
            return new Color(0f, 0.4f, 1f);
        }





        public void Start()
        {

            gameObject.GetComponent<LimbBehaviour>().IsZombie = true;

            foreach (var i in gameObject.transform.root.GetComponentsInChildren<LimbBehaviour>())
            {
                if (i.GetComponent<ReplicatorAura>() == null)
                {
                    i.gameObject.AddComponent<ReplicatorAura>();
                }

            }
        }

        public void OnCollisionEnter2D(Collision2D other)
        {
            if (other.gameObject.GetComponent<ReplicatorAura>() == null && other.gameObject.GetComponent<LimbBehaviour>())
            {


                other.gameObject.AddComponent<ReplicatorAura>();



            }

        }



    }


    public class reverseAura : Powers
    {

        private GameObject Ruka;
        private BoxCollider2D bc;


        public override string powerSpriteName()
        {
            return null;
        }
        public override string powerSpriteNameUpg()
        {
            return null;
        }

        public override Color color1()
        {
            return new Color(0f, 1f, 1f);
        }



        public override void Nullificator()
        {

        }



        public override void Awake()
        {
            Ruka = gameObject;




            bc = gameObject.AddComponent<BoxCollider2D>() as BoxCollider2D;
            bc.size = new Vector2(2.0f, 2.0f);
            bc.isTrigger = true;
            bc.transform.parent = Ruka.transform;
        }

        public void OnTriggerEnter2D(Collider2D other)
        {


            if (other.gameObject.GetComponent<LimbBehaviour>() != null)
            {
                other.gameObject.SendMessage("rev", SendMessageOptions.DontRequireReceiver);

            }


        }



    }



    public class Spike : Powers
    {

        public override string powerSpriteName()
        {
            return null;
        }
        public override string powerSpriteNameUpg()
        {
            return ("spiker55");
        }



        public override Color color1()
        {
            return new Color(0.5f, 0.5f, 0.5f, 0.25f);
        }


        public override void Awake()
        {

            base.Awake();



            var component = ObjectWithPower.GetComponent<PhysicalBehaviour>();
            var chelovek = ModAPI.FindPhysicalProperties("Human");
            chelovek.Sharp = true;
            chelovek.SharpAxes = new[]
            {
                                    new SharpAxis(Vector2.down, 0f, 0.55f, false, true),
                                };
            component.Properties = chelovek;


        }

        public void OnCollisionEnter2D(Collision2D other)
        {
            if (upgraded == true)
            {


                other.gameObject.GetComponent<LimbBehaviour>().CirculationBehaviour.AddLiquid(Liquid.GetLiquid("????"), 1.4f);
            }

        }

 

    }

    public class NullAura : Powers
    {

        public override string powerSpriteName()
        {
            return "rukaudar";
        }
        public override string powerSpriteNameUpg()
        {
            return null;
        }

        public override Color color1()
        {
            return new Color32(60, 47, 234, 100);
        }



        public void OnCollisionEnter2D(Collision2D other)
        {
            if (other.gameObject.GetComponent<LimbBehaviour>() != null)
            {
                other.gameObject.GetComponent<SpriteRenderer>().color = new Color(1f, 1f, 1f, 1f);
                other.gameObject.GetComponent<LimbBehaviour>().Frozen = false;
            }
            other.gameObject.SendMessage("Nullificator", SendMessageOptions.DontRequireReceiver);


        }

        public override void upg()
        {

        }




    }


    public class FallenGravityPower : Powers
    {

        public override Color color1()
        {
            return new Color(0.7f, 0.1f, 0.1f, 0.3f);
        }
        public override string powerSpriteName()
        {
            return null;
        }
        public override string powerSpriteNameUpg()
        {
            return null;
        }


        private bool cd;
        //private GameObject Ruka;
        public PhysicalBehaviour physicalBehaviour;
        //  private GameObject RukaGlow;
        //public bool upgraded = false;


        public override void Awake()
        {
            ObjectWithPower = gameObject;
            ObjectGlow = new GameObject();
            ObjectGlow.transform.parent = ObjectWithPower.transform;
            ObjectGlow.transform.localPosition = new Vector3(0f, 0f);
            ObjectGlow.transform.localRotation = Quaternion.identity;

            ObjectGlow.transform.localScale = new Vector3(1f, 1f);
            var RukaSprite = ObjectGlow.AddComponent<SpriteRenderer>();

            RukaSprite.sprite = ModAPI.LoadSprite("textures/mask.png");
            RukaSprite.material = ModAPI.FindMaterial("VeryBright");
            RukaSprite.color = new Color(1f, 1f, 1f, 0f);
            RukaSprite.sortingLayerName = "Top";
            ObjectGlow.transform.localRotation = Quaternion.identity;
            BoxCollider2D bc;
            bc = gameObject.AddComponent<BoxCollider2D>() as BoxCollider2D;
            bc.size = new Vector2(3.0f, 3.0f);
            bc.isTrigger = true;
            bc.transform.parent = ObjectWithPower.transform;



        }



        public void OnTriggerEnter2D(Collider2D other)
        {

            if (upgraded == true)
            {
                if (other.gameObject.GetComponent<LimbBehaviour>() == null & other.gameObject.GetComponent<soul>() == null)
                {
                    ModAPI.CreateParticleEffect("Disintegration", other.gameObject.GetComponent<Rigidbody2D>().position);

                    other.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                }
            }



        }















        private IEnumerator lechenie()
        {
            cd = true;
            var items = Global.main.PhysicalObjectsInWorld.ToArray();



            if (upgraded == true)
            {


                for (int i = 0; i < Global.main.PhysicalObjectsInWorld.Count; i++)
                {




                    if (items[i].transform.root != this.transform.root)
                    {
                        items[i].GetComponent<Rigidbody2D>().velocity *= 10;
                    }


                }
            }
            var oldgrav = Physics2D.gravity;
            Physics2D.gravity = new Vector2(0, UnityEngine.Random.Range(-11, 6));
            yield return new WaitForSeconds(1f);
            Physics2D.gravity = oldgrav;
            cd = false;
        }


        public override void upg()
        {
            if (upgraded == false)
            {
                upgraded = true;


                ModAPI.CreateParticleEffect("HugeZap", ObjectWithPower.transform.position);
                ModAPI.CreateParticleEffect("PinkExplosion", ObjectWithPower.transform.position);
                ModAPI.CreateParticleEffect("Vapor", ObjectWithPower.transform.position);

                ObjectGlow.GetComponent<SpriteRenderer>().color = new Color(1f, 1f, 1f, 0.05f);

            }
        }


        public void Use()
        {
            if (cd == false)
            {
                StartCoroutine(lechenie());
            }
        }

        public override void rev()
        {
            if (upgraded == false)
            {
                ModAPI.CreateParticleEffect("HugeZap", ObjectWithPower.transform.position);
                ModAPI.CreateParticleEffect("HugeZap", ObjectWithPower.transform.position);
                ModAPI.CreateParticleEffect("HugeZap", ObjectWithPower.transform.position);
                ModAPI.CreateParticleEffect("Vapor", ObjectWithPower.transform.position);
                ObjectWithPower.gameObject.GetComponent<LimbBehaviour>().Crush();
            }

        }

    }

}




// Originally uploaded by 'Alibarda'. Do not reupload without their explicit permission.
