﻿using System;
using System.Collections.Generic;
using System.IO;
using UnityEngine;
using UnityEngine.Events;
using UnityEngine.UI;


namespace Mod
{
    public class Mod : MonoBehaviour
    {




            public static void Main()
        {
            CategoryBuilder.Create("HT", "", ModAPI.LoadSprite("textures/InGameIcon.png"));




            Liquid.Register("GoldInfection", new GoldPoison());
            Liquid.Register("???", new TempCrushLiquid()); ;
            Liquid.Register("????", new VampireLiquid());




            ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Human"),
        NameOverride = "Slightly Improved Human " + " +HT",
        NameToOrderByOverride = "A1",
        DescriptionOverride = "A little stronger than the average human." + "\n <color=orange>[Tier 1] ",
        CategoryOverride = ModAPI.FindCategory("HT"),
        ThumbnailOverride = ModAPI.LoadSprite("textures/human1.png"),
        AfterSpawn = (Instance) =>
        {

            var person = Instance.GetComponent<PersonBehaviour>();
            
            foreach (var body in person.Limbs)
            {
                body.BaseStrength += 0.5f;
                body.Health *= 1.5f;
                body.InitialHealth *= 1.5f;
                body.ShotDamageMultiplier *= 0.7f;
                body.BreakingThreshold += 10f;
                body.RegenerationSpeed += 5f;
                body.Vitality *= 1.5f;
                body.ImpactPainMultiplier *= 0.5f;
                // body.Numbness *= 1.2f;
            }



        }
    });

            ModAPI.Register(
new Modification()
{
    OriginalItem = ModAPI.FindSpawnable("Human"),
    NameOverride = "Experimental Model" + " +HT",
    NameToOrderByOverride = "A2",
    DescriptionOverride = "Bites and infects others" + "\n <color=orange>[Tier 1] ",
    CategoryOverride = ModAPI.FindCategory("HT"),
    ThumbnailOverride = ModAPI.LoadSprite("textures/bit.png"),
    AfterSpawn = (Instance) =>
    {
        var person = Instance.GetComponent<PersonBehaviour>();
        var head = Instance.transform.Find("Head");
        head.gameObject.AddComponent<bite>();



        foreach (var body in person.Limbs)
        {

            body.Health *= 2.6f;
            body.InitialHealth *= 2.6f;

            body.RegenerationSpeed += 10f;

            body.IsZombie = true;


        }
        var skin = ModAPI.LoadTexture("textures/biter.png");
        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, null, null);
    }
}


);








            ModAPI.Register(
new Modification()
{
    OriginalItem = ModAPI.FindSpawnable("Human"),
    NameOverride = "Improved Human" + " +HT",
    NameToOrderByOverride = "A2",
    DescriptionOverride = "Stronger than the average human." + "\n <color=orange>[Tier 2] ",
    CategoryOverride = ModAPI.FindCategory("HT"),
    ThumbnailOverride = ModAPI.LoadSprite("textures/human2.png"),
    AfterSpawn = (Instance) =>
    {
        var person = Instance.GetComponent<PersonBehaviour>();

        foreach (var body in person.Limbs)
        {
            body.BaseStrength += 0.5f;
            body.Health *= 2.6f;
            body.InitialHealth *= 2.6f;
            body.ShotDamageMultiplier *= 0.6f;
            body.BreakingThreshold += 10f;
            body.RegenerationSpeed += 10f;
            body.Vitality *= 3f;
            body.ImpactPainMultiplier *= 0.2f;
            // body.Numbness *= 3f;
            //body.CirculationBehaviour.BloodFlow *= 4f;
            body.IsLethalToBreak = false;
        }


    }
}
);




            ModAPI.Register(
new Modification()
{
    OriginalItem = ModAPI.FindSpawnable("Human"),
    NameOverride = "A Highly Improved Human" + " +HT",
    NameToOrderByOverride = "A3",
    DescriptionOverride = "Much stronger than the average human. Has a limited and weak ability to regenerate. Regeneration disappears if you deals damage long enough" + "\n <color=orange>[Tier 3] ",
    CategoryOverride = ModAPI.FindCategory("HT"),
    ThumbnailOverride = ModAPI.LoadSprite("textures/human3.png"),
    AfterSpawn = (Instance) =>
    {
        var person = Instance.GetComponent<PersonBehaviour>();
        // arm1.gameObject.AddComponent<EnergySwordBehaviour>().BladeObject.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("textures/bowgun.png");
        var head = Instance.transform.Find("Head");
        head.gameObject.AddComponent<WeakRegen>().TimeDelay = 3f;
        foreach (var body in person.Limbs)
        {

            body.Health *= 7.6f;
            body.InitialHealth *= 7.6f;
            body.ShotDamageMultiplier *= 0.2f;
            body.BreakingThreshold += 10f;
            body.RegenerationSpeed += 10f;
            body.Vitality *= 3f;
            body.ImpactPainMultiplier *= 0f;
            body.Numbness *= 3f;
            body.CirculationBehaviour.BloodFlow *= 4f;
            body.IsLethalToBreak = false;

        }


    }
}
);













            ModAPI.Register(
new Modification()
{
    OriginalItem = ModAPI.FindSpawnable("Human"),
    NameOverride = "A Human with implant" + " +HT",
    NameToOrderByOverride = "A3",
    DescriptionOverride = "Much stronger than the average human. Can't bleed and doesn't feel pain" + "\n <color=orange>[Tier 3] ",
    CategoryOverride = ModAPI.FindCategory("HT"),
    ThumbnailOverride = ModAPI.LoadSprite("textures/chip.png"),
    AfterSpawn = (Instance) =>
    {
        var person = Instance.GetComponent<PersonBehaviour>();

        var head = Instance.transform.Find("Head");
        head.gameObject.AddComponent<ImplantRegen>().TimeDelay = 0f ;
        foreach (var body in person.Limbs)
        {

            body.Health *= 7.6f;
            body.InitialHealth *= 7.6f;
            body.ShotDamageMultiplier *= 0.2f;
            body.BreakingThreshold += 10f;
            body.RegenerationSpeed += 10f;
            body.Vitality *= 3f;
            body.ImpactPainMultiplier *= 0f;
            //body.Numbness *= 3f;
            //body.CirculationBehaviour.BloodFlow *= 4f;
            body.IsLethalToBreak = false;
           // body.gameObject.AddComponent<ImplantRegen>();
        }
        var skin = ModAPI.LoadTexture("textures/skinhuman2.png");
        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, null, null);
    }
}
);
            ModAPI.Register(
new Modification()
{
    OriginalItem = ModAPI.FindSpawnable("Human"),
    NameOverride = "Regenerator" + " +HT",
    NameToOrderByOverride = "A4",
    DescriptionOverride = "This human is stronger than the average person and have strong regenerative abilities." + "\n <color=orange>[Tier 4] ",
    CategoryOverride = ModAPI.FindCategory("HT"),
    ThumbnailOverride = ModAPI.LoadSprite("textures/human4.png"),
    AfterSpawn = (Instance) =>
    {
        var person = Instance.GetComponent<PersonBehaviour>();
        var head = Instance.transform.Find("Head");
        head.gameObject.AddComponent<BodyRegenPassive>();
        foreach (var body in person.Limbs)
        {

            body.Health *= 2.6f;
            body.InitialHealth *= 2.6f;
            body.ShotDamageMultiplier *= 0.2f;
            body.BreakingThreshold += 10f;
            body.RegenerationSpeed += 10f;
            body.Vitality *= 3f;
            body.ImpactPainMultiplier *= 0.2f;
            body.Numbness *= 3f;
            body.CirculationBehaviour.BloodFlow *= 4f;
            body.IsLethalToBreak = false;

            // body.gameObject.GetComponent<ConsciousnessRegen>().time = 2f;

        }


    }
}
);

            //ModAPI.Register(
            //    new Modification()
            //    {
            //        OriginalItem = ModAPI.FindSpawnable("Human"),
            //        NameOverride = "⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀⠀",
            //        DescriptionOverride = "Piece of Somebody.\nWhat was it before? \nA hero, a god, or a creature created by someone who hates humanity?" + "\n <color=#ffC0cb>[Tier ???]",
            //        CategoryOverride = ModAPI.FindCategory("HT"),
            //        ThumbnailOverride = ModAPI.LoadSprite("textures/human4.png"),
            //        AfterSpawn = (Instance) =>
            //        {
            //            var person = Instance.GetComponent<PersonBehaviour>();

            //            //parts
            //            var armLeft = Instance.transform.Find("FrontArm");
            //            var armRight = Instance.transform.Find("BackArm");
            //            var legLeft = Instance.transform.Find("FrontLeg");
            //            var legRight = Instance.transform.Find("BackLeg");
            //            var head = Instance.transform.Find("Head");
            //            var Body= Instance.transform.Find("Body");




            //            //woot
            //            Body.localScale = new Vector3(1.35f, 1f, 1f);
            //            Body.Find("LowerBody").localPosition = new Vector3(0f, -0.035f, 0f);

            //            head.localPosition = new Vector3(0f, 0.8f, 0f);

            //            armLeft.localPosition = new Vector3(-0.2f, 0.475f, 0f);
            //            armLeft.localRotation = Quaternion.Euler(0f, 0f, -90f);
            //            armRight.localPosition = new Vector3(0.2f, 0.475f, 0f);

            //            armRight.localRotation = Quaternion.Euler(0f, 0f, 90f);

            //            armLeft.Find("UpperArmFront").localScale = new Vector3(1.1f, 1f, 1f);
            //            armRight.Find("UpperArm").localScale = new Vector3(1.1f, 1f, 1f);

            //            legLeft.localPosition = new Vector3(-0.1f, 0.045f, 0f);
            //            legLeft.localScale = new Vector3(1.2f, 1f, 1f);
            //            legRight.localPosition = new Vector3(0.1f, 0.045f, 0f);
            //            legRight.localScale = new Vector3(1.2f, 1f, 1f);

            //            legLeft.Find("LowerLegFront").localPosition = new Vector3(0.015f, -0.85f, 0f);
            //            legLeft.Find("LowerLegFront").localScale = new Vector3(0.80f, 1.2f, 1f);
            //            legRight.Find("LowerLeg").localPosition = new Vector3(-0.015f, -0.85f, 0f);
            //            legRight.Find("LowerLeg").localScale = new Vector3(0.80f, 1.2f, 1f);





            //            foreach (var body in person.Limbs)
            //            {
            //                body.PhysicalBehaviour.rigidbody.gravityScale *= 0.2f;
            //                body.PhysicalBehaviour.rigidbody.mass *= 2f;
            //                body.IsLethalToBreak = false;


            //            }
            //        }
            //    }
            //);



            ModAPI.Register(
            new Modification()
            {
                OriginalItem = ModAPI.FindSpawnable("Human"),
                NameOverride = "Acid Human" + " +HT",
                DescriptionOverride = "Deals acid damage on hit." + "\n <color=orange>[Tier 3] ",
                NameToOrderByOverride = "A3",
                CategoryOverride = ModAPI.FindCategory("HT"),
                ThumbnailOverride = ModAPI.LoadSprite("textures/acid.png"),

                AfterSpawn = (Instance) =>
                {
                    var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
                    var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");
                    var person = Instance.GetComponent<PersonBehaviour>();
                    arm1.gameObject.AddComponent<AcidPower>();
                    arm2.gameObject.AddComponent<AcidPower>();
                   // var head = Instance.transform.Find("Head");
                    //head.gameObject.AddComponent<BodyRegenPassive>();
                    foreach (var body in person.Limbs)
                    {
                        ;
                        body.Health *= 2.6f;
                        body.InitialHealth *= 2.6f;
                        body.ShotDamageMultiplier *= 0.2f;
                        body.BreakingThreshold += 10f;
                        body.RegenerationSpeed += 10f;
                        body.Vitality *= 3f;
                        body.ImpactPainMultiplier *= 0.2f;
                        body.Numbness *= 3f;
                        body.CirculationBehaviour.BloodFlow *= 4f;
                        body.IsLethalToBreak = false;
                        // body.gameObject.AddComponent<ConsciousnessRegen>().spec = false;
                    }


                }
            }
            );







            ModAPI.Register(
new Modification()
{
    OriginalItem = ModAPI.FindSpawnable("Human"),
    NameOverride = "The Tester" + " +HT",
    NameToOrderByOverride = "A4",
    DescriptionOverride = "Activate head to swap positions with the person it is looking at \n<b><i> We must continue the experiments, it's the only way we can get revenge on them and prove that you are truly the enemy of humanity.</b></i>" + "\n <color=orange>[Tier 4] ",
    CategoryOverride = ModAPI.FindCategory("HT"),
    ThumbnailOverride = ModAPI.LoadSprite("textures/hh.png"),
    AfterSpawn = (Instance) =>
    {
        var person = Instance.GetComponent<PersonBehaviour>();
        var head = Instance.transform.Find("Head");
        head.gameObject.AddComponent<SwitchPlaces>();
        head.gameObject.AddComponent<ImplantRegen>();
        foreach (var body in person.Limbs)
        {
            ;
            body.Health *= 7.6f;
            body.InitialHealth *= 7.6f;
            body.ShotDamageMultiplier *= 0.2f;
            body.BreakingThreshold += 10f;
            body.RegenerationSpeed += 10f;
            body.Vitality *= 2f;
            body.ImpactPainMultiplier *= 0f;
            body.Numbness *= 2f;
            body.CirculationBehaviour.BloodFlow *= 2f;
            body.IsLethalToBreak = false;

        }
        var skin = ModAPI.LoadTexture("textures/headhunter.png");
        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, null, null);
    }
}
);

            //            ModAPI.Register(
            //new Modification()
            //{
            //    OriginalItem = ModAPI.FindSpawnable("Human"),
            //    NameOverride = "???" + " +HT",
            //    DescriptionOverride = "." + "\n <color=orange>[Tier 4] ",
            //    NameToOrderByOverride = "A4",
            //    CategoryOverride = ModAPI.FindCategory("HT"),
            //    ThumbnailOverride = ModAPI.LoadSprite("textures/acid.png"),

            //    AfterSpawn = (Instance) =>
            //    {
            //        var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
            //        var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");
            //        var head = Instance.transform.Find("Head");


            //        var upper = Instance.transform.Find("Body").Find("UpperBody");
            //        arm1.GetComponent<LimbBehaviour>().ImmuneToDamage = true;
            //        arm2.GetComponent<LimbBehaviour>().ImmuneToDamage = true;
            //        head.GetComponent<LimbBehaviour>().ImmuneToDamage = true;
            //        upper.GetComponent<LimbBehaviour>().ImmuneToDamage = true;

            //        head.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Metal");
            //        upper.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Metal");
            //        arm1.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Metal");
            //        arm2.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Metal");


            //        var person = Instance.GetComponent<PersonBehaviour>();

            //        foreach (var body in person.Limbs)
            //        {
            //            ;
            //            body.Health *= 2.6f;
            //            body.InitialHealth *= 2.6f;
            //            body.ShotDamageMultiplier *= 0.2f;
            //            body.BreakingThreshold += 10f;
            //            body.RegenerationSpeed += 10f;
            //            body.Vitality *= 3f;
            //            body.ImpactPainMultiplier *= 0.2f;
            //            body.Numbness *= 3f;
            //            body.CirculationBehaviour.BloodFlow *= 4f;
            //            body.IsLethalToBreak = false;
            //            body.gameObject.AddComponent<NoSleep3>();
            //        }


            //    }
            //}
            //);

            ModAPI.Register(
new Modification()
{
    OriginalItem = ModAPI.FindSpawnable("Human"),
    NameOverride = "The Midas" + " +HT",
    DescriptionOverride = "Turns flesh into a gold.." + "\n <color=orange>[Tier 4] ",
    NameToOrderByOverride = "A4",
    CategoryOverride = ModAPI.FindCategory("HT"),
    ThumbnailOverride = ModAPI.LoadSprite("textures/midas.png"),

    AfterSpawn = (Instance) =>
    {
        var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
        var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");
        var head = Instance.transform.Find("Head");

        GameObject crown = new GameObject();
        crown.transform.parent = head;
        crown.transform.localPosition = new Vector3(0f, 0.3f);
        crown.transform.localScale = new Vector3(0.3f, 0.3f);

        var crownSprite = crown.AddComponent<SpriteRenderer>();

        crownSprite.sprite = ModAPI.LoadSprite("textures/crown.png");
        crownSprite.material = ModAPI.FindMaterial("VeryBright");
        crownSprite.color = new Color(1f, 1f, 0f, 0.25f);
        crownSprite.sortingLayerName = "Top";


        var person = Instance.GetComponent<PersonBehaviour>();
        arm1.gameObject.AddComponent<MidasPower>();
        arm2.gameObject.AddComponent<MidasPower>();
        head.gameObject.AddComponent<ConsciousnessRegen>().Resists.Add(ResistData.MidasResist);
        foreach (var body in person.Limbs)
        {
            //;
            body.Health *= 2.6f;
            body.InitialHealth *= 2.6f;
            body.ShotDamageMultiplier *= 0.2f;
            body.BreakingThreshold += 10f;
            body.RegenerationSpeed += 10f;
            body.Vitality *= 3f;
            body.ImpactPainMultiplier *= 0.2f;
            //body.Numbness *= 3f;
            body.CirculationBehaviour.BloodFlow *= 4f;
            body.IsLethalToBreak = false;

        }


    }
}
);
            ModAPI.Register(
new Modification()
{
    OriginalItem = ModAPI.FindSpawnable("Human"),
    NameOverride = "The Overloader" + " +HT",
    DescriptionOverride = "Activate head to overload humans nervous systems in close proximity" + "\n <color=orange>[Tier 4] ",
    NameToOrderByOverride = "A4",
    CategoryOverride = ModAPI.FindCategory("HT"),
    ThumbnailOverride = ModAPI.LoadSprite("textures/OverLoader.png"),

    AfterSpawn = (Instance) =>
    {

        var head = Instance.transform.Find("Head");

        GameObject crown = new GameObject();
        crown.transform.parent = head;
        crown.transform.localPosition = new Vector3(0f, 0f);
        crown.transform.localScale = new Vector3(1f, 1f);

        var crownSprite = crown.AddComponent<SpriteRenderer>();

        crownSprite.sprite = ModAPI.LoadSprite("textures/glazaprost.png");
        crownSprite.material = ModAPI.FindMaterial("VeryBright");
        crownSprite.color = new Color(0.1f, 0.1f, 0.2f, 0.50f);
        crownSprite.sortingLayerName = "Top";

        head.gameObject.AddComponent<SleepAura>();
        var person = Instance.GetComponent<PersonBehaviour>();

        //head.gameObject.AddComponent<ConsciousnessRegen>();
        foreach (var body in person.Limbs)
        {
  
        body.Health *= 2.6f;
            body.InitialHealth *= 2.6f;
            body.ShotDamageMultiplier *= 0.2f;
            body.BreakingThreshold += 10f;
            body.RegenerationSpeed += 10f;
            body.Vitality *= 3f;
            body.ImpactPainMultiplier *= 0.2f;

        body.CirculationBehaviour.BloodFlow *= 4f;
            body.IsLethalToBreak = false;

        }


    }
}
);





            ModAPI.Register(
            new Modification()
            {
                OriginalItem = ModAPI.FindSpawnable("Human"),
                NameOverride = "Crusher" + " +HT",
                NameToOrderByOverride = "A5",
                DescriptionOverride = "Rip & Tear." + "\n <color=orange>[Tier 5] ",
                CategoryOverride = ModAPI.FindCategory("HT"),
                ThumbnailOverride = ModAPI.LoadSprite("textures/crusher.png"),

                AfterSpawn = (Instance) =>
                {
                    var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
                    var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");
                    var head = Instance.transform.Find("Head");
                    GameObject alsoEye = new GameObject();
                    alsoEye.transform.parent = head;
                    alsoEye.transform.localPosition = new Vector3(0f, 0f);
                    alsoEye.transform.localScale = new Vector3(1f, 1f);

                    var eyeSprite = alsoEye.AddComponent<SpriteRenderer>();

                    eyeSprite.sprite = ModAPI.LoadSprite("textures/Glaz.png");
                    eyeSprite.material = ModAPI.FindMaterial("VeryBright");
                    eyeSprite.color = new Color(0.5f, 0.2f, 0.8f, 0.65f);
                    eyeSprite.sortingLayerName = "Top";
                    var person = Instance.GetComponent<PersonBehaviour>();
                    arm1.gameObject.AddComponent<CrusherPower>();
                    arm2.gameObject.AddComponent<CrusherPower>();
                    head.gameObject.AddComponent<ConsciousnessRegen>().Resists.Add(ResistData.CrusherResist);
                    foreach (var body in person.Limbs)
                    {
                        body.Health *= 4.6f;
                        body.InitialHealth *= 4.6f;
                        body.ShotDamageMultiplier *= 0.2f;
                        body.BreakingThreshold += 10f;
                        body.RegenerationSpeed += 10f;
                        body.Vitality *= 3f;
                        body.ImpactPainMultiplier *= 0.2f;
                        body.Numbness *= 3f;
                        body.CirculationBehaviour.BloodFlow *= 4f;
                        body.IsLethalToBreak = false;

                    }


                }
            }
            );

            ModAPI.Register(
new Modification()
{
    OriginalItem = ModAPI.FindSpawnable("Human"),
    NameOverride = "The Rotten God " + " +HT",
    NameToOrderByOverride = "A6",
    DescriptionOverride = "Disintegrates flesh nearbly." + "\n <color=red>[Tier 6] ",
    CategoryOverride = ModAPI.FindCategory("HT"),
    ThumbnailOverride = ModAPI.LoadSprite("textures/roten.png"),

    AfterSpawn = (Instance) =>
    {

        var head = Instance.transform.Find("Head");

        head.gameObject.AddComponent<RottenGodAura>();

        var person = Instance.GetComponent<PersonBehaviour>();


        head.gameObject.AddComponent<BodyRegenPassive>().Resists.Add(ResistData.RottenGodResist);




        foreach (var body in person.Limbs)
        {
            ;
            body.Health *= 2.6f;
            body.InitialHealth *= 2.6f;
            body.ShotDamageMultiplier *= 0.2f;
            body.BreakingThreshold += 10f;
            body.RegenerationSpeed += 10f;
            body.Vitality *= 3f;
            body.ImpactPainMultiplier *= 0.2f;
            body.Numbness *= 3f;
            body.CirculationBehaviour.BloodFlow *= 4f;
            body.IsLethalToBreak = false;




        }
        var skin = ModAPI.LoadTexture("textures/skin.png");
        var ske = ModAPI.LoadTexture("textures/skeleton2.png");


        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, null, ske);
        person.SetBruiseColor(0, 0, 0); //main bruise colour. purple-ish by default
        person.SetSecondBruiseColor(10, 10, 10); //second bruise colour. red by default
        person.SetThirdBruiseColor(1, 1, 1); // third bruise colour. light yellow by default
        person.SetBloodColour(10, 10, 10);
    }
}
);
            ModAPI.Register(
new Modification()
{
    OriginalItem = ModAPI.FindSpawnable("Human"),
    NameOverride = "Absorber" + " +HT",
    NameToOrderByOverride = "A5",
    DescriptionOverride = "Can absorb other humans to become stronger." + "\n <color=orange>[Tier 5] ",
    CategoryOverride = ModAPI.FindCategory("HT"),
    ThumbnailOverride = ModAPI.LoadSprite("textures/absorb.png"),

    AfterSpawn = (Instance) =>
    {

        var person = Instance.GetComponent<PersonBehaviour>();

        foreach (var body in person.Limbs)
        {
            ;
            body.Health *= 4.6f;
            body.InitialHealth *= 4.6f;
            body.ShotDamageMultiplier *= 0.2f;
            body.BreakingThreshold += 10f;
            body.RegenerationSpeed += 10f;
            body.Vitality *= 3f;
            body.ImpactPainMultiplier *= 0.2f;
            body.Numbness *= 3f;
            body.CirculationBehaviour.BloodFlow *= 4f;
            body.IsLethalToBreak = false;
            body.gameObject.AddComponent<AbsorberPower>();

        }
        var skin = ModAPI.LoadTexture("textures/skin1.png");
        var none = ModAPI.LoadTexture("textures/none.png");
        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, null, null);

    }
}
);











            ModAPI.Register(
            new Modification()
            {
                OriginalItem = ModAPI.FindSpawnable("Human"),
                NameOverride = "Nullificator" + " +HT",
                NameToOrderByOverride = "A7",
                DescriptionOverride = "Can nullify most of the powers" + "\n <color=purple>[Tier 7]",
                CategoryOverride = ModAPI.FindCategory("HT"),
                ThumbnailOverride = ModAPI.LoadSprite("textures/nullif.png"),

                AfterSpawn = (Instance) =>
                {
                    var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
                    var person = Instance.GetComponent<PersonBehaviour>();
                    var head = Instance.transform.Find("Head");
                    //head.gameObject.AddComponent<ConsciousnessRegen>();

                    arm1.gameObject.AddComponent<NullAura>();
                    foreach (var body in person.Limbs)
                    {
                        ;
                        body.Health *= 2.6f;
                        body.InitialHealth *= 2.6f;
                        body.ShotDamageMultiplier *= 0.2f;
                        body.BreakingThreshold += 10f;
                        body.RegenerationSpeed += 10f;
                        body.Vitality *= 3f;
                        body.ImpactPainMultiplier *= 0.2f;
                        body.Numbness *= 3f;
                        body.CirculationBehaviour.BloodFlow *= 4f;
                        body.IsLethalToBreak = false;

                    }


                }
            }
            );

            ModAPI.Register(
new Modification()
{
    OriginalItem = ModAPI.FindSpawnable("Human"),
    NameOverride = "Replicator X1-5" + " +HT",
    DescriptionOverride = "Infects other humans on touch." + "\n <color=orange>[Tier 2] ",
    NameToOrderByOverride = "A2",
    CategoryOverride = ModAPI.FindCategory("HT"),
    ThumbnailOverride = ModAPI.LoadSprite("textures/replic.png"),
    AfterSpawn = (Instance) =>
    {
        var person = Instance.GetComponent<PersonBehaviour>();
        var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
        foreach (var body in person.Limbs)
        {
            body.BaseStrength += 0.1f;
            body.Health *= 2.6f;
            body.InitialHealth *= 2.6f;
            body.ShotDamageMultiplier *= 0.2f;
            body.BreakingThreshold += 10f;
            body.RegenerationSpeed += 10f;
            body.Vitality *= 3f;
            body.IsZombie = true;
            body.ImpactPainMultiplier *= 0.2f;
            body.Numbness *= 3f;
            body.CirculationBehaviour.BloodFlow *= 4f;
            body.IsLethalToBreak = false;

        }
        arm1.gameObject.AddComponent<ReplicatorAura>();

    }
}
);

            ModAPI.Register(
 new Modification()
 {
     OriginalItem = ModAPI.FindSpawnable("Human"),
     NameOverride = "The Great Champion" + " +HT",
     NameToOrderByOverride = "A6",
     DescriptionOverride = "Infinity punch power.Living matter disappear without a trace in a couple of seconds after being hit" + "\n <color=red>[Tier 6] ",
     CategoryOverride = ModAPI.FindCategory("HT"),
     ThumbnailOverride = ModAPI.LoadSprite("textures/champ.png"),

     AfterSpawn = (Instance) =>
     {
         var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
         var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");
         var head = Instance.transform.Find("Head");
         GameObject alsoEye = new GameObject();
         alsoEye.transform.parent = head;
         alsoEye.transform.localPosition = new Vector3(0f, 0f);
         alsoEye.transform.localScale = new Vector3(1f, 1f);

         var eyeSprite = alsoEye.AddComponent<SpriteRenderer>();

         eyeSprite.sprite = ModAPI.LoadSprite("textures/Glaz2.png");
         eyeSprite.material = ModAPI.FindMaterial("VeryBright");
         eyeSprite.color = new Color(0.8f, 0.8f, 0.8f, 0.1f);
         eyeSprite.sortingLayerName = "Top";
         var person = Instance.GetComponent<PersonBehaviour>();
         arm1.gameObject.AddComponent<ChampionPower>();
         arm2.gameObject.AddComponent<ChampionPower>();


        // head.gameObject.AddComponent<ConsciousnessRegen>();

         foreach (var body in person.Limbs)
         {
             ;
             body.Health *= 1000f;
             body.InitialHealth *= 1000f;
             body.ShotDamageMultiplier *= -2f;
             body.BreakingThreshold *= 1000f;
             body.RegenerationSpeed += 1000f;
             body.Vitality *= 1000f;
             body.ImpactPainMultiplier *= 0f;
             body.Numbness *= 3f;
             body.CirculationBehaviour.BloodFlow *= 1000f;
             body.IsLethalToBreak = false;



         }


     }
 }
 );
            ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Human"),
        NameOverride = "Giant human +HT",
        DescriptionOverride = "<color=orange>[Tier 2]",
        NameToOrderByOverride = "A2",
        CategoryOverride = ModAPI.FindCategory("HT"),
        ThumbnailOverride = ModAPI.LoadSprite("textures/6621.png"),
        AfterSpawn = (Instance) =>
        {
            var person = Instance.GetComponent<PersonBehaviour>();
            var head = Instance.transform.Find("Head");
            //head.gameObject.AddComponent<ConsciousnessRegen>();
            var skin = ModAPI.LoadTexture("textures/bigSkin.png");
            person.SetBodyTextures(skin, null, null);

            foreach (var body in person.Limbs)
            {
                body.transform.root.localScale *= 1.03f;
                body.Health *= 40f;
                body.BaseStrength *= 1.2f;
                body.BreakingThreshold *= 55f;

            }
        }
    }
);

            ModAPI.Register(
new Modification()
{
    OriginalItem = ModAPI.FindSpawnable("Human"),
    NameOverride = "Star Glitcher" + " +HT",
    NameToOrderByOverride = "A7",
    DescriptionOverride = "Strong gravitational anomaly surrounds his body. \n <b><i>The last scholar of <color=#ffC0cb>Z'othra</color>.</i></b>" + "\n <color=purple>[Tier 7] ",
    CategoryOverride = ModAPI.FindCategory("HT"),
    ThumbnailOverride = ModAPI.LoadSprite("textures/star.png"),
    AfterSpawn = (Instance) =>
    {
        var person = Instance.GetComponent<PersonBehaviour>();


        var head = Instance.transform.Find("Head");
        head.gameObject.AddComponent<ConsciousnessRegen>().Resists.Add(ResistData.CrusherResist);
        head.gameObject.AddComponent<GravityAura>();




        foreach (var body in person.Limbs)
        {
            body.BaseStrength += 0.1f;
            body.Health *= 2.6f;
            body.InitialHealth *= 2.6f;
            body.ShotDamageMultiplier *= 0.2f;
            body.BreakingThreshold += 10f;
            body.RegenerationSpeed += 10f;
            body.Vitality *= 3f;
            body.IsZombie = true;
            body.ImpactPainMultiplier *= 0.2f;
            body.Numbness *= 3f;
            body.CirculationBehaviour.BloodFlow *= 2f;
            body.IsLethalToBreak = false;
            body.PhysicalBehaviour.MakeWeightless();
            body.transform.root.localScale *= 1.04f;

            //body.ExplodeLiquidAmount *= 200f;
        }
        var skin = ModAPI.LoadTexture("textures/forgottenone.png");
        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, null, null);

    }
}
);


            ModAPI.Register(
new Modification()
{
    OriginalItem = ModAPI.FindSpawnable("Human"),
    NameOverride = "The Enemy of Humanity" + " +HT",
    NameToOrderByOverride = "A7",
    DescriptionOverride = "Can absorb some people with powers to gain their powers. \n Right click on the hand to reset the current ability" + "\n <color=purple>[Tier 7] ",
    CategoryOverride = ModAPI.FindCategory("HT"),
    ThumbnailOverride = ModAPI.LoadSprite("textures/absorb2.png"),
    AfterSpawn = (Instance) =>
    {
        var person = Instance.GetComponent<PersonBehaviour>();


        var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
        arm1.gameObject.AddComponent<EnemyPower>();
        var head = Instance.transform.Find("Head");
        var Rg = head.gameObject.AddComponent<BodyRegenPassive>();
        Rg.Resists.Add(ResistData.ChampionResist);
        Rg.Resists.Add(ResistData.RottenGodResist);
        Rg.Resists.Add(ResistData.BleedResist);
        Rg.Resists.Add(ResistData.ZeloVelocityResist);

        foreach (var body in person.Limbs)
        {
            body.BaseStrength += 0.1f;
            body.Health *= 2.6f;
            body.InitialHealth *= 2.6f;
            body.ShotDamageMultiplier *= 0.2f;
            body.BreakingThreshold += 10f;
            body.RegenerationSpeed += 10f;
            body.Vitality *= 3f;
            body.ImpactPainMultiplier *= 0.2f;
            body.Numbness *= 3f;

            body.CirculationBehaviour.BloodFlow *= 4f;
            body.IsLethalToBreak = false;

        }
        var skin = ModAPI.LoadTexture("textures/enemy.png");
        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, null, null);

    }
}
);


            ModAPI.Register(
new Modification()
{
    OriginalItem = ModAPI.FindSpawnable("Human"),
    NameOverride = "Healer" + " +HT",
    NameToOrderByOverride = "A4",
    DescriptionOverride = "Heals nearby humans" + "\n <color=orange>[Tier 4] ",
    CategoryOverride = ModAPI.FindCategory("HT"),
    ThumbnailOverride = ModAPI.LoadSprite("textures/heal1.png"),
    AfterSpawn = (Instance) =>
    {
        var person = Instance.GetComponent<PersonBehaviour>();
        var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
        var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");
        arm1.gameObject.AddComponent<Heal>();
       // var head = Instance.transform.Find("Head");
        //head.gameObject.AddComponent<ConsciousnessRegen>();
        foreach (var body in person.Limbs)
        {
            body.BaseStrength += 0.1f;
            body.Health *= 2.6f;
            body.InitialHealth *= 2.6f;
            body.ShotDamageMultiplier *= 0.2f;
            body.BreakingThreshold += 10f;
            body.RegenerationSpeed += 10f;
            body.Vitality *= 3f;
            body.ImpactPainMultiplier *= 0.2f;
            body.Numbness *= 3f;
            body.CirculationBehaviour.BloodFlow *= 4f;
            body.IsLethalToBreak = false;
            // body.gameObject.AddComponent<HealBeh>();

        }


    }
}
);
            ModAPI.Register(
new Modification()
{
    OriginalItem = ModAPI.FindSpawnable("Human"),
    NameOverride = "Toge" + " +HT",
    NameToOrderByOverride = "A3",
    DescriptionOverride = "They used to be people too." + "\n <color=orange>[Tier 3] ",
    CategoryOverride = ModAPI.FindCategory("HT"),
    ThumbnailOverride = ModAPI.LoadSprite("textures/toge.png"),
    AfterSpawn = (Instance) =>
    {
        var person = Instance.GetComponent<PersonBehaviour>();

        var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
        var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");





        arm1.gameObject.AddComponent<Spike>();
        arm2.gameObject.AddComponent<Spike>();

        foreach (var body in person.Limbs)
        {
            body.BaseStrength += 0.1f;
            body.Health *= 1.6f;
            body.InitialHealth *= 1.6f;
            body.ShotDamageMultiplier *= 0.6f;
            body.BreakingThreshold += 10f;
            body.RegenerationSpeed += 4f;
            body.Vitality *= 3f;
            body.ImpactPainMultiplier *= 0.2f;
            body.Numbness *= 3f;
            body.CirculationBehaviour.BloodFlow *= 4f;
            body.IsLethalToBreak = false;


        }

        var skin = ModAPI.LoadTexture("textures/spiker.png");
        var flesh = ModAPI.LoadTexture("textures/fleshlayer2.png");
        var bone = ModAPI.LoadTexture("textures/bonelayer1.png");
        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone);

    }
}
);
            ModAPI.Register(
new Modification()
{
    OriginalItem = ModAPI.FindSpawnable("Human"),
    NameOverride = "E.M.P. Operative" + " +HT",
    NameToOrderByOverride = "A3",
    DescriptionOverride = "Damages electronics around himself " + "\n <color=orange>[Tier 3] ",
    CategoryOverride = ModAPI.FindCategory("HT"),
    ThumbnailOverride = ModAPI.LoadSprite("textures/emp.png"),
    AfterSpawn = (Instance) =>
    {
        var person = Instance.GetComponent<PersonBehaviour>();
        var upper = Instance.transform.Find("Body").Find("UpperBody");

        upper.gameObject.AddComponent<EmpAgent>();
        //var head = Instance.transform.Find("Head");
        //head.gameObject.AddComponent<ConsciousnessRegen>();

        GameObject backpacks = new GameObject();
        backpacks.transform.parent = upper;
        backpacks.transform.localPosition = new Vector2(-0.25f, 0f);
        backpacks.transform.localScale = new Vector2(1.5f, 1.5f);

        var backpacksprite = backpacks.AddComponent<SpriteRenderer>();

        backpacksprite.sprite = ModAPI.LoadSprite("textures/backpack.png");


        foreach (var body in person.Limbs)
        {
            body.BaseStrength += 0.1f;
            body.Health *= 1.6f;
            body.InitialHealth *= 1.6f;
            body.BreakingThreshold += 10f;
            body.Vitality *= 3f;
            body.ImpactPainMultiplier *= 0.2f;
            body.Numbness *= 3f;
            body.CirculationBehaviour.BloodFlow *= 2f;

        }


    }
}
);
            ModAPI.Register(
new Modification()
{
    OriginalItem = ModAPI.FindSpawnable("Human"),
    NameOverride = "Flame human" + " +HT",
    DescriptionOverride = "Flame punch!" + "\n <color=orange>[Tier 4] ",
    CategoryOverride = ModAPI.FindCategory("HT"),
    NameToOrderByOverride = "A4",
    ThumbnailOverride = ModAPI.LoadSprite("textures/flame.png"),
    AfterSpawn = (Instance) =>
    {
        var person = Instance.GetComponent<PersonBehaviour>();

        var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
        var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");

        arm1.gameObject.AddComponent<Firebeh>();
        arm2.gameObject.AddComponent<Firebeh>();

        foreach (var body in person.Limbs)
        {
            body.BaseStrength += 0.1f;
            body.Health *= 1.6f;
            body.InitialHealth *= 1.6f;
            body.ShotDamageMultiplier *= 0.6f;
            body.BreakingThreshold += 10f;
            body.RegenerationSpeed += 4f;
            body.Vitality *= 3f;
            body.ImpactPainMultiplier *= 0.2f;
            body.Numbness *= 3f;
            body.CirculationBehaviour.BloodFlow *= 4f;
            body.IsLethalToBreak = false;

            // body.gameObject.GetComponent<PhysicalBehaviour>().Properties.ShallowClone().Flammability = 0f;
            body.gameObject.GetComponent<PhysicalBehaviour>().Properties.Flammability = 0f;
            body.gameObject.GetComponent<PhysicalBehaviour>().Properties.Burnrate = 0f;
            body.InternalToExternalTempTransferRate = 0f;
            body.DiscomfortingHeatTemperature += 2000f;
            body.PhysicalBehaviour.BurningProgressionMultiplier = 0f;
            body.PhysicalBehaviour.burnIntensity = 0f;

        }


    }
}
);
            ModAPI.Register(
new Modification()
{
    OriginalItem = ModAPI.FindSpawnable("Human"),
    NameOverride = "The Leidrigo" + " +HT",
    DescriptionOverride = "Electric punch!" + "\n <color=orange>[Tier 5] ",
    CategoryOverride = ModAPI.FindCategory("HT"),
    NameToOrderByOverride = "A5",
    ThumbnailOverride = ModAPI.LoadSprite("textures/elec.png"),
    AfterSpawn = (Instance) =>
    {
        var person = Instance.GetComponent<PersonBehaviour>();

        var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
        var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");

        var head = Instance.transform.Find("Head");

        head.gameObject.AddComponent<ElecGunPower>();
        arm1.gameObject.AddComponent<ElectroPower>();
        arm2.gameObject.AddComponent<ElectroPower>();


        //head.gameObject.AddComponent<ConsciousnessRegen>();
        foreach (var body in person.Limbs)
        {
            body.BaseStrength += 0.1f;
            body.Health *= 1.6f;
            body.InitialHealth *= 1.6f;
            body.ShotDamageMultiplier *= 0.6f;
            body.BreakingThreshold += 10f;
            body.RegenerationSpeed += 4f;
            body.Vitality *= 3f;
            body.ImpactPainMultiplier *= 0.2f;
            body.Numbness *= 3f;
            body.CirculationBehaviour.BloodFlow *= 4f;
            body.IsLethalToBreak = false;
            // body.gameObject.AddComponent<nofire>();


            body.gameObject.GetComponent<PhysicalBehaviour>().Properties.Conducting = false;


        }


    }
}
);




            ModAPI.Register(
new Modification()
{
    OriginalItem = ModAPI.FindSpawnable("Human"),
    NameOverride = "Duality Elemental" + " +HT",
    NameToOrderByOverride = "A5",
    DescriptionOverride = "One hand kills everything that it touches, the other one heals" + "\n <color=orange>[Tier 5] ",
    CategoryOverride = ModAPI.FindCategory("HT"),
    ThumbnailOverride = ModAPI.LoadSprite("textures/duality.png"),
    AfterSpawn = (Instance) =>
    {
        var person = Instance.GetComponent<PersonBehaviour>();

        var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
        var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");

        arm1.gameObject.AddComponent<dualkill>();
        arm2.gameObject.AddComponent<dualheal>();
        var head = Instance.transform.Find("Head");
        //head.gameObject.AddComponent<ConsciousnessRegen>();

        foreach (var body in person.Limbs)
        {
            ;
            body.Health *= 2.6f;
            body.InitialHealth *= 2.6f;
            body.ShotDamageMultiplier *= 0.2f;
            body.BreakingThreshold += 10f;
            body.RegenerationSpeed += 10f;
            body.Vitality *= 3f;
            body.ImpactPainMultiplier *= 0.4f;
            body.Numbness *= 3f;
            body.CirculationBehaviour.BloodFlow *= 4f;
            body.IsLethalToBreak = false;


        }
        var skin = ModAPI.LoadTexture("textures/dual.png");
        var flesh = ModAPI.LoadTexture("textures/dualflesh.png");
        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, null);

    }
}
);
            ModAPI.Register(
new Modification()
{
    OriginalItem = ModAPI.FindSpawnable("Human"),
    NameOverride = "Dwade The Fallen" + " +HT",
    NameToOrderByOverride = "A8",
    DescriptionOverride = "Activate head to release a powerful gravitational pulse over all the lab \n <b><i>The voice of the long dead <color=#ffC0cb>Z'othra</color> still resounds in his head.</b></i> " + "\n <color=green>[Tier 8] ",
    CategoryOverride = ModAPI.FindCategory("HT"),
    ThumbnailOverride = ModAPI.LoadSprite("textures/Dwade.png"),
    AfterSpawn = (Instance) =>
    {
        var person = Instance.GetComponent<PersonBehaviour>();

        var head = Instance.transform.Find("Head");


        head.gameObject.AddComponent<FallenGravityPower>();
        GameObject alsoEye = new GameObject();
        alsoEye.transform.parent = head;
        alsoEye.transform.localPosition = new Vector3(0f, 0f);
        alsoEye.transform.localScale = new Vector3(1f, 1f);

        var eyeSprite = alsoEye.AddComponent<SpriteRenderer>();

        eyeSprite.sprite = ModAPI.LoadSprite("textures/sym.png");
        eyeSprite.material = ModAPI.FindMaterial("VeryBright");
        eyeSprite.color = new Color(1f, 0f, 0f, 0.1f);
        eyeSprite.sortingLayerName = "Top";

        foreach (var body in person.Limbs)
        {
            //body.BaseStrength += 0.f;
            body.Health *= 85f;
            body.InitialHealth *= 85f;
            body.ShotDamageMultiplier *= 0f;
            body.BreakingThreshold *= 99999;
            body.RegenerationSpeed += 4f;
            body.Vitality *= 3f;
            body.ImpactPainMultiplier *= 0f;
            body.Numbness *= 3f;
            body.CirculationBehaviour.BloodFlow *= 4f;
            body.IsLethalToBreak = false;
            body.BloodDecal = null;
            body.gameObject.AddComponent<ImmortalityBehaviour>();
            body.PhysicalBehaviour.ReflectsLasers = true;
            //body.transform.gameObject.SetLayer(10, true);
            // body.ExplodeLiquidAmount *= 200f;

        }

        var skin = ModAPI.LoadTexture("textures/soulEater.png");
        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, null, null);
    }
}
);


            ModAPI.Register(
            new Modification()
            {
                OriginalItem = ModAPI.FindSpawnable("Human"),
                NameOverride = "Stasis human" + " +HT",
                DescriptionOverride = "Stops moving objects" + "\n <color=orange>[Tier 4] ",
                NameToOrderByOverride = "A4",
                CategoryOverride = ModAPI.FindCategory("HT"),
                ThumbnailOverride = ModAPI.LoadSprite("textures/static.png"),

                AfterSpawn = (Instance) =>
                {
                    var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
                    var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");
                    var person = Instance.GetComponent<PersonBehaviour>();
                    var head = Instance.transform.Find("Head");
                    head.gameObject.AddComponent<ConsciousnessRegen>().Resists.Add(ResistData.ZeloVelocityResist);
                    arm1.gameObject.AddComponent<ZeloVelocityPower>();

                    foreach (var body in person.Limbs)
                    {
                        ;
                        body.Health *= 2.6f;
                        body.InitialHealth *= 2.6f;
                        body.ShotDamageMultiplier *= 0.2f;
                        body.BreakingThreshold += 10f;
                        body.RegenerationSpeed += 10f;
                        body.Vitality *= 3f;
                        body.ImpactPainMultiplier *= 0.2f;
                        body.Numbness *= 3f;
                        body.CirculationBehaviour.BloodFlow *= 4f;
                        body.IsLethalToBreak = false;


                    }


                }
            }
            );

            ModAPI.Register(
new Modification()
{
    OriginalItem = ModAPI.FindSpawnable("Android"),
    NameOverride = "The Artificial God" + " +HT",
    DescriptionOverride = "Turns the powers of the gifted against themselves" + "\n<b><i> <color=#ffC0cb>Z'othra</color> is no more.The Machine is now slowly marching through Void, looking like searching for something.Something it will never find.Artificial God just needs to find something... Or someone..." + "\n<color=green>[Tier 8] ",
    NameToOrderByOverride = "A8",
    CategoryOverride = ModAPI.FindCategory("HT"),
    ThumbnailOverride = ModAPI.LoadSprite("textures/ai.png"),

    AfterSpawn = (Instance) =>
    {
        var head = Instance.transform.Find("Head");
        var person = Instance.GetComponent<PersonBehaviour>();

        head.gameObject.AddComponent<reverseAura>();

        var Regen = head.gameObject.AddComponent<BodyRegenPassive>();
        Regen.TimeDelay = 100f;
        Regen.Resists.Add(ResistData.CrusherResist);
        Regen.Resists.Add(ResistData.RottenGodResist);
        Regen.Resists.Add(ResistData.ZombieBiteResist);
        Regen.Resists.Add(ResistData.BarrierResist);
        Regen.Resists.Add(ResistData.ChampionResist);
        Regen.Resists.Add(ResistData.ExplosiveResist);
        Regen.Resists.Add(ResistData.MidasResist);
        Regen.Resists.Add(ResistData.ZeloVelocityResist);
        Regen.Resists.Add(ResistData.VoidTransformResist);
        Regen.Resists.Add(ResistData.BleedResist);
        foreach (var body in person.Limbs)
        {
            ;
            body.Health *= 52.6f;
            body.InitialHealth *= 52.6f;
            body.ShotDamageMultiplier = 0f;
            // body.CirculationBehaviour.AddLiquid(Liquid.GetLiquid(body.BloodLiquidType), 200f);
            body.BreakingThreshold += 10f;
            body.RegenerationSpeed += 5f;
            body.Vitality *= 3f;
            body.ImpactPainMultiplier *= 0.2f;
            body.Numbness *= 3f;
            body.CirculationBehaviour.BloodFlow *= 4f;
            body.gameObject.AddComponent<ImmortalityBehaviour>();

        }

        var skin = ModAPI.LoadTexture("textures/reverse.png");
        var f = ModAPI.LoadTexture("textures/fleshlayer3.png");
        var b = ModAPI.LoadTexture("textures/skeleton1.png");
        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, f, b);
    }
}
);

            ModAPI.Register(
new Modification()
{
    OriginalItem = ModAPI.FindSpawnable("Human"),
    NameOverride = "SKULL-X1-6" + " +HT",
    DescriptionOverride = "Activate his arm to shoot" + "\n <color=orange>[Tier 4] ",
    CategoryOverride = ModAPI.FindCategory("HT"),
    NameToOrderByOverride = "A4",
    ThumbnailOverride = ModAPI.LoadSprite("textures/gun.png"),
    AfterSpawn = (Instance) =>
    {
        var person = Instance.GetComponent<PersonBehaviour>();
        var head = Instance.transform.Find("Head");
       // head.gameObject.AddComponent<ConsciousnessRegen>();
        var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");


        arm1.gameObject.AddComponent<GunPower>();
        Destroy(arm1.GetComponent<GripBehaviour>());



        foreach (var body in person.Limbs)
        {
            body.BaseStrength += 0.5f;
            body.Health *= 1.6f;
            body.InitialHealth *= 1.6f;
            body.ShotDamageMultiplier *= 0.6f;
            body.BreakingThreshold += 10f;
            body.RegenerationSpeed += 4f;
            body.Vitality *= 3f;
            body.ImpactPainMultiplier *= 0.2f;
            body.Numbness *= 3f;
            body.CirculationBehaviour.BloodFlow *= 4f;
            body.IsLethalToBreak = false;


        }


    }
}
);

            ModAPI.Register(
new Modification()
{
    OriginalItem = ModAPI.FindSpawnable("Human"),
    NameOverride = "The Blast" + " +HT",
    DescriptionOverride = "Touch the object to mark it.Activate hand to explode all marked objects" + "\n <color=orange>[Tier 5] ",
    NameToOrderByOverride = "A5",
    CategoryOverride = ModAPI.FindCategory("HT"),
    ThumbnailOverride = ModAPI.LoadSprite("textures/deton.png"),

    AfterSpawn = (Instance) =>
    {
        var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
        var person = Instance.GetComponent<PersonBehaviour>();
        var head = Instance.transform.Find("Head");
        head.gameObject.AddComponent<ConsciousnessRegen>().Resists.Add(ResistData.ExplosiveResist);
        arm1.gameObject.AddComponent<ExploPower>();

        foreach (var body in person.Limbs)
        {
            ;
            body.Health *= 2.6f;
            body.InitialHealth *= 2.6f;
            body.ShotDamageMultiplier *= 0.2f;
            body.BreakingThreshold += 10f;
            body.RegenerationSpeed += 10f;
            body.Vitality *= 3f;
            body.ImpactPainMultiplier *= 0.2f;
            body.Numbness *= 3f;
            body.CirculationBehaviour.BloodFlow *= 4f;
            body.IsLethalToBreak = false;


        }


    }
}
);
            ModAPI.Register(
new Modification()
{
    OriginalItem = ModAPI.FindSpawnable("Human"),
    NameOverride = "Buresu" + " +HT",
    DescriptionOverride = "Causes internal bleeding in nearby humans" + "\n<b><i> They can't suppress <color=#ffC0cb>it</color> forever" + "\n <color=orange>[Tier 5] ",
    NameToOrderByOverride = "A5",
    CategoryOverride = ModAPI.FindCategory("HT"),
    ThumbnailOverride = ModAPI.LoadSprite("textures/bbb.png"),

    AfterSpawn = (Instance) =>
    {

        var person = Instance.GetComponent<PersonBehaviour>();
        var head = Instance.transform.Find("Head");

        head.gameObject.AddComponent<ConsciousnessRegen>().Resists.Add(ResistData.BleedResist);
        head.gameObject.AddComponent<BleedAura>();

        foreach (var body in person.Limbs)
        {
            body.BaseStrength += 1f;
            body.Health *= 2.6f;
            body.InitialHealth *= 2.6f;
            body.ShotDamageMultiplier *= 0.2f;
            body.BreakingThreshold += 10f;
            body.RegenerationSpeed += 10f;
            body.Vitality *= 3f;
            body.ImpactPainMultiplier *= 0.2f;
            body.Numbness *= 3f;
            body.CirculationBehaviour.BloodFlow *= 4f;
            body.IsLethalToBreak = false;





        }
        var skin = ModAPI.LoadTexture("textures/Ox.png");
        Instance.GetComponent<PersonBehaviour>().SetBloodColour(0, 0, 200);
        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, null, null);

    }
}
);


            ModAPI.Register(
new Modification()
{
    OriginalItem = ModAPI.FindSpawnable("Human"),
    NameOverride = "The Shell" + " +HT",
    DescriptionOverride = "I wonder what can be put in it " + "\n <color=#ffC0cb>[Tier ???] ",
    NameToOrderByOverride = "b1",
    CategoryOverride = ModAPI.FindCategory("HT"),
    ThumbnailOverride = ModAPI.LoadSprite("textures/shellprev.png"),

    AfterSpawn = (Instance) =>
    {
        var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
        var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");

        var person = Instance.GetComponent<PersonBehaviour>();
        var head = Instance.transform.Find("Head");
        var middle = Instance.transform.Find("Body").Find("MiddleBody");

        arm1.gameObject.AddComponent<ShellPunch>();
        arm2.gameObject.AddComponent<ShellPunch>();
        head.GetComponent<PhysicalBehaviour>().Disintegratable = false;
        middle.GetComponent<PhysicalBehaviour>().Disintegratable = false;
        arm1.GetComponent<PhysicalBehaviour>().Disintegratable = false;
        arm2.GetComponent<PhysicalBehaviour>().Disintegratable = false;
        middle.gameObject.AddComponent<Core>();

        head.gameObject.AddComponent<ShellAwake>();


        var Regen = head.gameObject.AddComponent<ConsciousnessRegen>();
        Regen.Resists.Add(ResistData.CrusherResist);
        Regen.Resists.Add(ResistData.RottenGodResist);
        Regen.Resists.Add(ResistData.ZombieBiteResist);
        Regen.Resists.Add(ResistData.BarrierResist);
        Regen.Resists.Add(ResistData.ChampionResist);
        Regen.Resists.Add(ResistData.ExplosiveResist);
        Regen.Resists.Add(ResistData.MidasResist);
        Regen.Resists.Add(ResistData.ZeloVelocityResist);
        Regen.Resists.Add(ResistData.VoidTransformResist);
        Regen.Resists.Add(ResistData.BleedResist);



        head.gameObject.AddComponent<Shell>();

        // head.gameObject.AddComponent<Pulse>();
        head.gameObject.AddComponent<LazerEye>();
        foreach (var body in person.Limbs)
        {

            body.Health *= 2.6f;
            body.InitialHealth *= 2.6f;
            body.ShotDamageMultiplier *= 0.2f;


            body.Person.SetBloodColour(2, 2, 2);
            body.RegenerationSpeed += 10f;
            body.Vitality *= 3f;
            body.ImpactPainMultiplier *= 0.2f;
            body.Numbness *= 3f;
            body.CirculationBehaviour.BloodFlow *= 4f;
            body.IsLethalToBreak = false;
            body.BreakingThreshold = float.PositiveInfinity;
            // body.ExplodeLiquidAmount = 9999f;

            body.FreezingTemperature = -999999f;
            body.DiscomfortingHeatTemperature = 999999f;



            body.gameObject.GetComponent<PhysicalBehaviour>().BurningProgressionMultiplier = 0f;
            body.gameObject.GetComponent<PhysicalBehaviour>().Properties.BurningTemperatureThreshold = 99999f;
            body.gameObject.GetComponent<PhysicalBehaviour>().ReflectsLasers = true;

        }
        var skin = ModAPI.LoadTexture("textures/Lost.png");
        var flesh = ModAPI.LoadTexture("textures/lostFlesh.png");
        var S = ModAPI.LoadTexture("textures/lostskeleton.png");

        Instance.GetComponent<PersonBehaviour>().SetBloodColour(0, 0, 0);
        Instance.GetComponent<PersonBehaviour>().SetBruiseColor(0, 0, 0);
        Instance.GetComponent<PersonBehaviour>().SetSecondBruiseColor(0, 0, 0);
        Instance.GetComponent<PersonBehaviour>().SetThirdBruiseColor(0, 0, 0);
        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, S);

    }
}
);













            ModAPI.Register(
new Modification()
{
    OriginalItem = ModAPI.FindSpawnable("Human"),
    NameOverride = "Hayu'Ko" + " +HT",
    DescriptionOverride = "Gives humans a low tier powers" + "\n <color=red>[Tier 6]",
    CategoryOverride = ModAPI.FindCategory("HT"),
    NameToOrderByOverride = "A6",
    ThumbnailOverride = ModAPI.LoadSprite("textures/21.png"),
    AfterSpawn = (Instance) =>
    {
        var person = Instance.GetComponent<PersonBehaviour>();

        var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");


        arm1.gameObject.AddComponent<PowerGive>();

        var head = Instance.transform.Find("Head");

        //head.gameObject.AddComponent<ConsciousnessRegen>();


        foreach (var body in person.Limbs)
        {
            body.BaseStrength += 0.1f;
            body.Health *= 1.6f;
            body.InitialHealth *= 1.6f;
            body.ShotDamageMultiplier *= 0.6f;
            body.BreakingThreshold += 10f;
            body.RegenerationSpeed += 4f;
            body.Vitality *= 3f;
            body.ImpactPainMultiplier *= 0.2f;
            body.Numbness *= 3f;
            body.CirculationBehaviour.BloodFlow *= 4f;
            body.IsLethalToBreak = false;


        }
        var skin = ModAPI.LoadTexture("textures/Hayu.png");
        var flesh = ModAPI.LoadTexture("textures/gFlesh.png");
        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, null);

    }
}
);








            ModAPI.Register(
                          new Modification()
                          {
                              OriginalItem = ModAPI.FindSpawnable("Brick"),
                              NameOverride = "A piece of <color=#ffC0cb>Z'othra's</color> soul",
                              DescriptionOverride = "Allows some of the gifted to reach their full potential",
                              NameToOrderByOverride = "b1",
                              CategoryOverride = ModAPI.FindCategory("HT"),
                              ThumbnailOverride = ModAPI.LoadSprite("textures/singularity.png"),
                              AfterSpawn = (Instance) =>
                              {
                                  foreach (var c in Instance.GetComponents<Collider2D>())
                                  {
                                      GameObject.Destroy(c);
                                  }
                                  Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("textures/singularity.png");
                                  Instance.GetComponent<SpriteRenderer>().material = ModAPI.FindMaterial("VeryBright");
                                  Instance.GetComponent<SpriteRenderer>().color = new Color(1f, 0.5f, 0.8f, 1f);
                                  Instance.AddComponent<CircleCollider2D>();
                                  Instance.AddComponent<soul>();
                              }
                          }


                      );
            //  ModAPI.Register(
            //   new Modification()
            //   {
            //       OriginalItem = ModAPI.FindSpawnable("Brick"),
            //       NameOverride = "Power Tank",
            //       DescriptionOverride = "Can take away, store, and transfer the abilities of Gifted humans \nRight click to change mode",
            //       NameToOrderByOverride = "b1",
            //       CategoryOverride = ModAPI.FindCategory("HT"),
            //       ThumbnailOverride = ModAPI.LoadSprite("textures/battery.png"),
            //       AfterSpawn = (Instance) =>
            //       {
            //           foreach (var c in Instance.GetComponents<Collider2D>())
            //           {
            //               GameObject.Destroy(c);
            //           }

            //           Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("textures/battery.png");
            //           Instance.FixColliders();






            //          var RukaGlow = new GameObject();
            //           RukaGlow.transform.SetParent(Instance.transform);
            //           RukaGlow.transform.localPosition = new Vector3(0f, 0f);

            //           var RukaSprite = RukaGlow.AddComponent<SpriteRenderer>();

            //           RukaSprite.sprite = ModAPI.LoadSprite("textures/battery1.png");
            //           RukaSprite.material = ModAPI.FindMaterial("VeryBright");
            //           RukaSprite.color = new Color(1f, 0f, 0f, 0.2f);
            //           RukaSprite.sortingLayerName = "Top";




            //           RukaGlow.transform.localScale = new Vector3(1f, 1f);

            //           var RukaGlow1 = new GameObject();

            //           RukaGlow1.transform.SetParent(Instance.transform);

            //           RukaGlow1.transform.localPosition = new Vector3(0f, 0f);

            //           RukaGlow.transform.localRotation = Quaternion.identity;
            //           RukaGlow1.transform.localRotation = Quaternion.identity;
            //           var RukaSprite1 = RukaGlow1.AddComponent<SpriteRenderer>();

            //           RukaSprite1.sprite = ModAPI.LoadSprite("textures/battery2.png");

            //           RukaSprite1.material = ModAPI.FindMaterial("VeryBright");

            //           RukaGlow1.transform.localScale = new Vector3(1f, 1f);
            //           RukaSprite1.sortingLayerName = "Top";
            //           RukaSprite1.color = new Color(0f, 0f, 0f, 0.2f);

            //           Instance.AddComponent<BoxCollider2D>();
            //           Instance.AddComponent<Gifts>();
            //       }
            //   }


            //);
            ModAPI.Register(
            new Modification()
            {
                OriginalItem = ModAPI.FindSpawnable("Brick"),
                NameOverride = "The Meishu",
                DescriptionOverride = "gives human completely random abilities on contact",
                NameToOrderByOverride = "b1",
                CategoryOverride = ModAPI.FindCategory("HT"),
                ThumbnailOverride = ModAPI.LoadSprite("textures/lead.png"),
                AfterSpawn = (Instance) =>
                {
                    foreach (var c in Instance.GetComponents<Collider2D>())
                    {
                        GameObject.Destroy(c);
                    }

                    Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("textures/lead.png");
                    Instance.FixColliders();






                    var RukaGlow = new GameObject();
                    RukaGlow.transform.SetParent(Instance.transform);
                    RukaGlow.transform.localPosition = new Vector3(0f, 0f);

                    var RukaSprite = RukaGlow.AddComponent<SpriteRenderer>();

                    RukaSprite.sprite = ModAPI.LoadSprite("textures/lead1.png");
                    RukaSprite.material = ModAPI.FindMaterial("VeryBright");
                    RukaSprite.color = new Color(1f, 0f, 0f, 0.2f);
                    RukaSprite.sortingLayerName = "Top";




                    RukaGlow.transform.localScale = new Vector3(1f, 1f);



                    Instance.AddComponent<Meishu>();
                }
            }


         );

            ModAPI.Register(
            new Modification()
            {
                OriginalItem = ModAPI.FindSpawnable("Brick"),
                NameOverride = "LH Toxin",
                DescriptionOverride = "Specially designed to get rid of regenerative abilities.It can be applied to any sharp object",
                NameToOrderByOverride = "b1",
                CategoryOverride = ModAPI.FindCategory("HT"),
                ThumbnailOverride = ModAPI.LoadSprite("textures/toxin.png"),
                AfterSpawn = (Instance) =>
                {
                    foreach (var c in Instance.GetComponents<Collider2D>())
                    {
                        GameObject.Destroy(c);
                    }

                    Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("textures/toxin.png");
                    Instance.FixColliders();
                    Instance.AddComponent<toxin>();


                }
            }


         );

            ModAPI.Register(
new Modification()
{
    OriginalItem = ModAPI.FindSpawnable("Human"),
    NameOverride = "The Sightless" + " +HT",
    NameToOrderByOverride = "A7",
    DescriptionOverride = "Causes transformation into a creature of the void by hitting with his hand. Activate hand to switch ability" + "\n<b><i><color=#5e5e5e>I got him out of the void, now we'll all be free, right?</i></b>" + "\n <color=purple>[Tier 7]",
    CategoryOverride = ModAPI.FindCategory("HT"),
    ThumbnailOverride = ModAPI.LoadSprite("textures/trait.png"),
    AfterSpawn = (Instance) =>
    {
        var person = Instance.GetComponent<PersonBehaviour>();

        var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
        arm1.gameObject.AddComponent<voidtouch>();

        var head = Instance.transform.Find("Head");

        var Regen = head.gameObject.AddComponent<ConsciousnessRegen>();


        Regen.Resists.Add(ResistData.CrusherResist);
        Regen.Resists.Add(ResistData.ZombieBiteResist);
        Regen.Resists.Add(ResistData.ChampionResist);
        Regen.Resists.Add(ResistData.ExplosiveResist);
        Regen.Resists.Add(ResistData.MidasResist);
        Regen.Resists.Add(ResistData.ZeloVelocityResist);
        Regen.Resists.Add(ResistData.VoidTransformResist);









        foreach (var body in person.Limbs)
        {


            ;
            body.Health *= 2.6f;
            body.InitialHealth *= 2.6f;
            body.ShotDamageMultiplier *= 0.2f;
            body.BreakingThreshold += 10f;
            body.RegenerationSpeed += 10f;
            body.Vitality *= 3f;
            body.Numbness *= 3f;
            //body.ExplodeLiquidAmount = 9999f;

            body.FreezingTemperature = -999999f;
            body.DiscomfortingHeatTemperature = 999999f;
            body.PhysicalBehaviour.ReflectsLasers = true;
            body.CirculationBehaviour.BloodFlow *= 4f;
            body.IsLethalToBreak = false;

        }
        var skin = ModAPI.LoadTexture("textures/Traitor.png");
        Instance.GetComponent<PersonBehaviour>().SetBruiseColor(0, 0, 0);
        Instance.GetComponent<PersonBehaviour>().SetSecondBruiseColor(0, 0, 0);
        Instance.GetComponent<PersonBehaviour>().SetThirdBruiseColor(0, 0, 0);
        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, null, null);

    }
}
);
            ModAPI.Register(
                         new Modification()
                         {
                             OriginalItem = ModAPI.FindSpawnable("Brick"),
                             NameOverride = "RG Implant container",
                             DescriptionOverride = "Contains an Implant. \nDue to its unstable nature, only one RG component can be applied to a Human",
                             NameToOrderByOverride = "c0",
                             CategoryOverride = ModAPI.FindCategory("HT"),
                             ThumbnailOverride = ModAPI.LoadSprite("textures/Implant.png"),
                             AfterSpawn = (Instance) =>
                             {
                                 foreach (var c in Instance.GetComponents<Collider2D>())
                                 {
                                     GameObject.Destroy(c);
                                 }
                                 Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("textures/Implant.png");

                                 Instance.AddComponent<CircleCollider2D>();

                                 var Comp = Instance.AddComponent<BodyPassiveAdder>();
                                 Comp.PassiveToAdd = new ImplantRegen();
                             }
                         }


                     );

            ModAPI.Register(
             new Modification()
             {
                 OriginalItem = ModAPI.FindSpawnable("Brick"),
                 NameOverride = "Unstable RG Extract",
                 DescriptionOverride = "Awakens the ability to regenerate in human upon contact. \nDue to its unstable nature, only one RG component can be applied to a Human",
                 NameToOrderByOverride = "c0",
                 CategoryOverride = ModAPI.FindCategory("HT"),
                 ThumbnailOverride = ModAPI.LoadSprite("textures/RegenCont.png"),
                 AfterSpawn = (Instance) =>
                 {
                     foreach (var c in Instance.GetComponents<Collider2D>())
                     {
                         GameObject.Destroy(c);
                     }
                     Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("textures/RegenCont.png");

                     Instance.AddComponent<BoxCollider2D>();

                     var Comp = Instance.AddComponent<BodyPassiveAdder>();
                     Comp.PassiveToAdd = new BodyRegenPassive();
                 }
             }


         );

            ModAPI.Register(
 new Modification()
 {
     OriginalItem = ModAPI.FindSpawnable("Brick"),
     NameOverride = "Weakened unstable RG Extract",
     DescriptionOverride = "Gives a person the ability to stay consciousness, even in the most extreme situations. \nDue to its unstable nature, only one RG component can be applied to a Human",
     NameToOrderByOverride = "c0",
     CategoryOverride = ModAPI.FindCategory("HT"),
     ThumbnailOverride = ModAPI.LoadSprite("textures/StableRegenCont.png"),
     AfterSpawn = (Instance) =>
     {
         foreach (var c in Instance.GetComponents<Collider2D>())
         {
             GameObject.Destroy(c);
         }
         Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("textures/StableRegenCont.png");

         Instance.AddComponent<BoxCollider2D>();

         var Comp = Instance.AddComponent<BodyPassiveAdder>();
         Comp.PassiveToAdd = new ConsciousnessRegen();
     }
 }


);




            ModAPI.Register(
             new Modification()
             {
                 OriginalItem = ModAPI.FindSpawnable("Brick"),
                 NameOverride = "RGRA : Anti-Crusher.",
                 DescriptionOverride = "RG Resistance Augmentation gives human with an implanted RG component a resistance to specific kind of power.",
                 NameToOrderByOverride = "c0",
                 CategoryOverride = ModAPI.FindCategory("HT"),
                 ThumbnailOverride = ModAPI.LoadSprite("textures/Argumentator.png"),
                 AfterSpawn = (Instance) =>
                 {
                     foreach (var c in Instance.GetComponents<Collider2D>())
                     {
                         GameObject.Destroy(c);
                     }
                     Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("textures/Argumentator.png");

                     Instance.AddComponent<CircleCollider2D>();

                     var Comp = Instance.AddComponent<BodyResistAdder>();
                     Comp.ResistToAdd =  ResistData.CrusherResist;
                 }
             }


         );


            ModAPI.Register(
 new Modification()
 {
     OriginalItem = ModAPI.FindSpawnable("Brick"),
     NameOverride = "RGRA : <color=#ffC0cb>UNKNOWN ENTITY</color></i></b> Barrier nullifier",
     DescriptionOverride = "RG Resistance Augmentation gives human with an implanted RG component a resistance to specific kind of power.",
     NameToOrderByOverride = "c0",
     CategoryOverride = ModAPI.FindCategory("HT"),
     ThumbnailOverride = ModAPI.LoadSprite("textures/Argumentator.png"),
     AfterSpawn = (Instance) =>
     {
         foreach (var c in Instance.GetComponents<Collider2D>())
         {
             GameObject.Destroy(c);
         }
         Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("textures/Argumentator.png");

         Instance.AddComponent<CircleCollider2D>();

         var Comp = Instance.AddComponent<BodyResistAdder>();
         Comp.ResistToAdd = ResistData.BarrierResist;
     }
 }


);


            ModAPI.Register(
             new Modification()
             {
                 OriginalItem = ModAPI.FindSpawnable("Brick"),
                 NameOverride = "RGRA : Buresu influence blocker.",
                 DescriptionOverride = "RG Resistance Augmentation gives human with an implanted RG component a resistance to specific kind of power.",
                 NameToOrderByOverride = "c0",
                 CategoryOverride = ModAPI.FindCategory("HT"),
                 ThumbnailOverride = ModAPI.LoadSprite("textures/Argumentator.png"),
                 AfterSpawn = (Instance) =>
                 {
                     foreach (var c in Instance.GetComponents<Collider2D>())
                     {
                         GameObject.Destroy(c);
                     }
                     Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("textures/Argumentator.png");

                     Instance.AddComponent<CircleCollider2D>();

                     var Comp = Instance.AddComponent<BodyResistAdder>();
                     Comp.ResistToAdd = ResistData.BleedResist;
                 }
             }


         );


            ModAPI.Register(
             new Modification()
             {
                 OriginalItem = ModAPI.FindSpawnable("Brick"),
                 NameOverride = "RGRA : 'Champion' type disintegration prevention.",
                 DescriptionOverride = "RG Resistance Augmentation gives human with an implanted RG component a resistance to specific kind of power.",
                 NameToOrderByOverride = "c0",
                 CategoryOverride = ModAPI.FindCategory("HT"),
                 ThumbnailOverride = ModAPI.LoadSprite("textures/Argumentator.png"),
                 AfterSpawn = (Instance) =>
                 {
                     foreach (var c in Instance.GetComponents<Collider2D>())
                     {
                         GameObject.Destroy(c);
                     }
                     Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("textures/Argumentator.png");

                     Instance.AddComponent<CircleCollider2D>();

                     var Comp = Instance.AddComponent<BodyResistAdder>();
                     Comp.ResistToAdd = ResistData.ChampionResist;
                 }
             }


         );



            ModAPI.Register(
 new Modification()
 {
     OriginalItem = ModAPI.FindSpawnable("Brick"),
     NameOverride = "RGRA : Blast detonation interrupter.",
     DescriptionOverride = "RG Resistance Augmentation gives human with an implanted RG component a resistance to specific kind of power.",
     NameToOrderByOverride = "c0",
     CategoryOverride = ModAPI.FindCategory("HT"),
     ThumbnailOverride = ModAPI.LoadSprite("textures/Argumentator.png"),
     AfterSpawn = (Instance) =>
     {
         foreach (var c in Instance.GetComponents<Collider2D>())
         {
             GameObject.Destroy(c);
         }
         Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("textures/Argumentator.png");

         Instance.AddComponent<CircleCollider2D>();

         var Comp = Instance.AddComponent<BodyResistAdder>();
         Comp.ResistToAdd = ResistData.ExplosiveResist;
     }
 }


);
            ModAPI.Register(
new Modification()
{
    OriginalItem = ModAPI.FindSpawnable("Brick"),
    NameOverride = "RGRA : Gold transformation preventer.",
    DescriptionOverride = "RG Resistance Augmentation gives human with an implanted RG component a resistance to specific kind of power.",
    NameToOrderByOverride = "c0",
    CategoryOverride = ModAPI.FindCategory("HT"),
    ThumbnailOverride = ModAPI.LoadSprite("textures/Argumentator.png"),
    AfterSpawn = (Instance) =>
    {
        foreach (var c in Instance.GetComponents<Collider2D>())
        {
            GameObject.Destroy(c);
        }
        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("textures/Argumentator.png");

        Instance.AddComponent<CircleCollider2D>();

        var Comp = Instance.AddComponent<BodyResistAdder>();
        Comp.ResistToAdd = ResistData.MidasResist;
    }
}


);



            ModAPI.Register(
new Modification()
{
OriginalItem = ModAPI.FindSpawnable("Brick"),
NameOverride = "RGRA : Rotten God Prayer Blocker.",
DescriptionOverride = "RG Resistance Augmentation gives human with an implanted RG component a resistance to specific kind of power.",
NameToOrderByOverride = "c0",
CategoryOverride = ModAPI.FindCategory("HT"),
ThumbnailOverride = ModAPI.LoadSprite("textures/Argumentator.png"),
AfterSpawn = (Instance) =>
{
foreach (var c in Instance.GetComponents<Collider2D>())
{
GameObject.Destroy(c);
}
Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("textures/Argumentator.png");

Instance.AddComponent<CircleCollider2D>();

var Comp = Instance.AddComponent<BodyResistAdder>();
Comp.ResistToAdd = ResistData.RottenGodResist;
}
}


);


            ModAPI.Register(
new Modification()
{
OriginalItem = ModAPI.FindSpawnable("Brick"),
NameOverride = "RGRA : Void transformation interrupter.",
DescriptionOverride = "RG Resistance Augmentation gives human with an implanted RG component a resistance to specific kind of power." + "\n<b><i>It did its part.\n\nEliminate.",
NameToOrderByOverride = "c0",
CategoryOverride = ModAPI.FindCategory("HT"),
ThumbnailOverride = ModAPI.LoadSprite("textures/Argumentator.png"),
AfterSpawn = (Instance) =>
{
foreach (var c in Instance.GetComponents<Collider2D>())
{
GameObject.Destroy(c);
}
Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("textures/Argumentator.png");

Instance.AddComponent<CircleCollider2D>();

var Comp = Instance.AddComponent<BodyResistAdder>();
Comp.ResistToAdd = ResistData.VoidTransformResist;
}
}


);




            ModAPI.Register(
new Modification()
{
OriginalItem = ModAPI.FindSpawnable("Brick"),
NameOverride = "RGRA : Zero Velocity Resistance.",
DescriptionOverride = "RG Resistance Augmentation gives human with an implanted RG component a resistance to specific kind of power.",
NameToOrderByOverride = "c0",
CategoryOverride = ModAPI.FindCategory("HT"),
ThumbnailOverride = ModAPI.LoadSprite("textures/Argumentator.png"),
AfterSpawn = (Instance) =>
{
foreach (var c in Instance.GetComponents<Collider2D>())
{
GameObject.Destroy(c);
}
Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("textures/Argumentator.png");

Instance.AddComponent<CircleCollider2D>();

var Comp = Instance.AddComponent<BodyResistAdder>();
Comp.ResistToAdd = ResistData.ZeloVelocityResist;
}
}


);


            ModAPI.Register(
new Modification()
{
OriginalItem = ModAPI.FindSpawnable("Brick"),
NameOverride = "RGRA : Bite proof skin.",
DescriptionOverride = "RG Resistance Augmentation gives human with an implanted RG component a resistance to specific kind of power.",
NameToOrderByOverride = "c0",
CategoryOverride = ModAPI.FindCategory("HT"),
ThumbnailOverride = ModAPI.LoadSprite("textures/Argumentator.png"),
AfterSpawn = (Instance) =>
{
foreach (var c in Instance.GetComponents<Collider2D>())
{
GameObject.Destroy(c);
}
Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("textures/Argumentator.png");

Instance.AddComponent<CircleCollider2D>();

var Comp = Instance.AddComponent<BodyResistAdder>();
Comp.ResistToAdd = ResistData.ZombieBiteResist;
}
}


);






            CreateSoul(ToLimb.TwoArms, new AcidPower(), "The Acid Human");
            CreateSoul(ToLimb.TwoArms, new CrusherPower(), "The Crusher");
            CreateSoul(ToLimb.TwoArms, new ChampionPower(), "The Great Champion");
            CreateSoul(ToLimb.TwoArms, new Firebeh(), "The Fire Human");
            CreateSoul(ToLimb.OneArm, new ExploPower(), "The Blast");
            CreateSoul(ToLimb.TwoArms, new fakevoidtouch(), "The Traitor");
            CreateSoul(ToLimb.OneArm, new GunPower(), "The SKULL-X1-6");
            CreateSoul(ToLimb.OneArm, new NullAura(), "The Nullificator");
            CreateSoul(ToLimb.Head, new GravityAura(), "The Star Glitcher");
            CreateSoul(ToLimb.OneArm, new EnemyPower(), "The Enemy of Humanity");
            CreateSoul(ToLimb.Head, new BleedAura(), "The Buresu");
            CreateSoul(ToLimb.Head, new RottenGodAura(), "The Rotten God");
            CreateSoul(ToLimb.OneArm, new ZeloVelocityPower(), "Stasis human");
            CreateSoul(ToLimb.OneArm, new PowerGive(), "The Meishu");
            CreateSoul(ToLimb.Head, new BitePower(), "The Experimental Model");
            CreateSoul(ToLimb.Head, new SwitchPlaces(), "The Tester");
            CreateSoul(ToLimb.TwoArms, new MidasPower(), "The Midas");
            CreateSoul(ToLimb.TwoArms, new ReplicatorAura(), "Replicator X1-5");
            CreateSoul(ToLimb.OneArm, new Heal(), "The Healer");
            CreateSoul(ToLimb.TwoArms, new Spike(), "The Toge");
            CreateSoul(ToLimb.OneArm, new dualkill (), "Duality Elemental's Hate");
            CreateSoul(ToLimb.OneBackArm, new dualheal(), "Duality Elemental's Love");
            CreateSoul(ToLimb.Head, new reverseAura(), "Last Will");
            CreateSoul(ToLimb.TwoArms, new ElectroPower(), "The Leidrigo's Punch");
            CreateSoul(ToLimb.Head, new ElecGunPower(), "The Leidrigo's hidden gift");
            CreateSoul(ToLimb.Head, new FallenGravityPower(), "The Fallen");
            CreateSoul(ToLimb.Head, new FallenGravityPower(), "E.M.P Agent Hate");

            CreateSoul(ToLimb.Head, new SleepAura(), "The Overloader");


            //            ModAPI.Register(
            //new Modification()
            //{
            //OriginalItem = ModAPI.FindSpawnable("Brick"),
            //NameOverride = "Test",
            //DescriptionOverride = "Test",
            //NameToOrderByOverride = "b5",
            //CategoryOverride = ModAPI.FindCategory("HT"),
            //ThumbnailOverride = ModAPI.LoadSprite("textures/Bolt.png"),
            //AfterSpawn = (Instance) =>
            //{


            ////Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("textures/Bolt.png");
            //foreach (var c in Instance.GetComponents<Collider2D>())
            //{
            // GameObject.Destroy(c);
            //}
            //Instance.AddComponent<BoxCollider2D>();
            //    Instance.AddComponent<Explo>();

            //}
            //}


            //);
            //            ModAPI.Register(
            //new Modification()
            //{
            //OriginalItem = ModAPI.FindSpawnable("Human"),
            //NameOverride = "TestHuman" + " +HT",
            //DescriptionOverride = "Activate his arm to shoot" + "\n <color=orange>[Tier 4] ",
            //CategoryOverride = ModAPI.FindCategory("HT"),
            //NameToOrderByOverride = "A4",
            //ThumbnailOverride = ModAPI.LoadSprite("textures/GunArm.png"),
            //AfterSpawn = (Instance) =>
            //{
            //var person = Instance.GetComponent<PersonBehaviour>();







            //foreach (var body in person.Limbs)
            //{
            //body.BaseStrength += 0.1f;
            //body.Health *= 1.6f;
            //body.InitialHealth *= 1.6f;
            //body.ShotDamageMultiplier *= 0.6f;
            //body.BreakingThreshold += 10f;
            //body.RegenerationSpeed += 4f;
            //body.Vitality *= 3f;
            //body.ImpactPainMultiplier *= 0.2f;
            //body.Numbness *= 3f;
            //        body.IsLethalToBreak = false;
            //body.gameObject.AddComponent<NoSleep3>();
            //        body.gameObject.GetComponent<LimbBehaviour>().PhysicalBehaviour.ConductOverride = false;

            //    }


            //}
            //}
            //);

        }



        public static void CreateSoul(ToLimb LimbToApply, Powers power, string Name)
        {

            Texture2D originalTexture = ModAPI.LoadSprite("textures/Essence.png").texture;
            Texture2D colorTexture = new Texture2D(originalTexture.width, originalTexture.height, TextureFormat.RGBA32, false);
            colorTexture.filterMode = FilterMode.Point;
            Color[] pixels = originalTexture.GetPixels();
            for (int i = 0; i < pixels.Length; i++)
            {
                if (pixels[i].a > 0f)
                {
                    pixels[i] = power.color1();
                }
            }
            colorTexture.SetPixels(pixels);
            colorTexture.Apply();


            Sprite originalSprite = ModAPI.LoadSprite("textures/Essence.png");
            Sprite EssenceSprite = Sprite.Create(
                colorTexture,
                originalSprite.rect,
                new Vector2(0.5f, 0.5f),
                originalSprite.pixelsPerUnit,
                0,
                SpriteMeshType.FullRect);


            ModAPI.Register(
                          new Modification()
                          {
                              OriginalItem = ModAPI.FindSpawnable("Brick"),
                              NameOverride = "Essence of " + Name,
                              DescriptionOverride = "Contains a sealed Energy",
                              NameToOrderByOverride = "c1",
                              CategoryOverride = ModAPI.FindCategory("HT"),
                              ThumbnailOverride = EssenceSprite,
                              AfterSpawn = (Instance) =>
                              {
                                  foreach (var c in Instance.GetComponents<Collider2D>())
                                  {
                                      GameObject.Destroy(c);
                                  }
                                  Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("textures/Essence.png");
                                  Instance.GetComponent<SpriteRenderer>().material = ModAPI.FindMaterial("VeryBright");
                                  Instance.GetComponent<SpriteRenderer>().color = power.color1();
                                  Instance.AddComponent<CircleCollider2D>();

                                  var Comp = Instance.AddComponent<Essence>();
                                  Comp.PowerToAdd = power;
                                  Comp.LimbToApply = LimbToApply;
                                  
                              }
                          }


                      );




        }



        public static void OnLoad()
        {
            if(PlayerPrefs.GetInt("OldHtShow3") == 0)
            {
                var dialog = (DialogBox)null;
                dialog = DialogBoxManager.Dialog("<b>Human Tiers Reforged</b> \n \n 3.0 Closed Beta of Human Tiers Remake mod is released on Patreon/Boosty! \n In our discord you can see news about development of the new mod, check Human Tiers mod page for links and details", new DialogButton[]
                {
                new DialogButton("Close", true),
                });
                PlayerPrefs.SetInt("OldHtShow3", 1);
            }




            powersprites.SpriteDictionary.Add("rukaudar.png", ModAPI.LoadSprite("textures/rukaudar.png"));
            powersprites.SpriteDictionary.Add("rukaudar1.png", ModAPI.LoadSprite("textures/rukaudar1.png"));
            powersprites.SpriteDictionary.Add("Braslet.png", ModAPI.LoadSprite("textures/Braslet.png"));
            powersprites.SpriteDictionary.Add("Braslet22.png", ModAPI.LoadSprite("textures/Braslet22.png"));
            powersprites.SpriteDictionary.Add("Braslet2.png", ModAPI.LoadSprite("textures/Braslet2.png"));
            powersprites.SpriteDictionary.Add("puncho3.png", ModAPI.LoadSprite("textures/puncho3.png"));
            powersprites.SpriteDictionary.Add("puncho.png", ModAPI.LoadSprite("textures/puncho.png"));
            powersprites.SpriteDictionary.Add("beam.png", ModAPI.LoadSprite("textures/beam.png"));
            powersprites.SpriteDictionary.Add("Brasletzo.png", ModAPI.LoadSprite("textures/Brasletzo.png"));
            powersprites.SpriteDictionary.Add("mask1.png", ModAPI.LoadSprite("textures/mask1.png"));
            //powersprites.SpriteDictionary.Add("BrokenHalo.png", ModAPI.LoadSprite("textures/BrokenHalo.png"));
            powersprites.SpriteDictionary.Add("glazaprost1.png", ModAPI.LoadSprite("textures/glazaprost1.png"));
            powersprites.SpriteDictionary.Add("Glaz3.png", ModAPI.LoadSprite("textures/Glaz3.png"));
            powersprites.SpriteDictionary.Add("singularity.png", ModAPI.LoadSprite("textures/singularity.png"));
            powersprites.SpriteDictionary.Add("GunArm.png", ModAPI.LoadSprite("textures/GunArm.png"));
            powersprites.SpriteDictionary.Add("pellet.png", ModAPI.LoadSprite("textures/pellet.png"));
            powersprites.SpriteDictionary.Add("it.png", ModAPI.LoadSprite("textures/it.png"));
            powersprites.SpriteDictionary.Add("forgottenone1.png", ModAPI.LoadSprite("textures/forgottenone1.png"));
            powersprites.SpriteDictionary.Add("Braslet44.png", ModAPI.LoadSprite("textures/Braslet44.png"));
            powersprites.SpriteDictionary.Add("Braslet45.png", ModAPI.LoadSprite("textures/Braslet45.png"));
            powersprites.SpriteDictionary.Add("spiker55.png", ModAPI.LoadSprite("textures/spiker55.png"));
            powersprites.SpriteDictionary.Add("void1.png", ModAPI.LoadSprite("textures/void1.png"));
            powersprites.SpriteDictionary.Add("void2.png", ModAPI.LoadSprite("textures/void2.png"));
            powersprites.SpriteDictionary.Add("void3.png", ModAPI.LoadSprite("textures/void3.png"));
            powersprites.SpriteDictionary.Add("void4.png", ModAPI.LoadSprite("textures/void4.png"));
            powersprites.SpriteDictionary.Add("BrokenHalo.png", ModAPI.LoadSprite("textures/BrokenHalo.png"));





        }








    }








    public class powersprites
    {
        public static Dictionary<string, Sprite> SpriteDictionary = new Dictionary<string, Sprite>();









    }

    public enum ToLimb
    {
        TwoArms,
        OneArm,
        Head,
        AllBody,
        HeadAndTwoArms,
        OneBackArm
    }



    public class Essence : MonoBehaviour
    {
        public ToLimb LimbToApply;
        public Powers PowerToAdd;



  
        public void OnCollisionEnter2D(Collision2D other)
        {
            if (other.gameObject.GetComponent<LimbBehaviour>() != null)
            {
                var limb = other.gameObject.GetComponent<LimbBehaviour>();
                var newpower = PowerToAdd.GetType();
                Powers addedPower;


                switch (LimbToApply)
                {
                    case ToLimb.AllBody:
                        foreach (var lmb in limb.Person.Limbs)
                        {
                            addedPower = lmb.gameObject.AddComponent(newpower) as Powers;
                        }
                        break;
                    case ToLimb.TwoArms:
                        addedPower = limb.transform.root.Find("FrontArm").Find("LowerArmFront").gameObject.AddComponent(newpower) as Powers;
                        addedPower = limb.transform.root.Find("BackArm").Find("LowerArm").gameObject.AddComponent(newpower) as Powers;
                        break;
                    case ToLimb.OneArm:
                        addedPower = limb.transform.root.Find("FrontArm").Find("LowerArmFront").gameObject.AddComponent(newpower) as Powers;
                        break;
                    case ToLimb.OneBackArm:
                        addedPower = limb.transform.root.Find("BackArm").Find("LowerArm").gameObject.AddComponent(newpower) as Powers;
                        break;
                    case ToLimb.Head:
                        addedPower = limb.transform.root.Find("Head").gameObject.AddComponent(newpower) as Powers;
                        break;
                    case ToLimb.HeadAndTwoArms:
                        addedPower = limb.transform.root.Find("Head").gameObject.AddComponent(newpower) as Powers;
                        addedPower = limb.transform.root.Find("FrontArm").Find("LowerArmFront").gameObject.AddComponent(newpower) as Powers;
                        addedPower = limb.transform.root.Find("BackArm").Find("LowerArm").gameObject.AddComponent(newpower) as Powers;
                        break;
                }






                var a = UnityEngine.Object.Instantiate<GameObject>(Resources.Load<GameObject>("Prefabs/SyringeExplosion"), this.transform.position, Quaternion.identity).GetComponent<SyringeExplosionBehaviour>();
                if (PowerToAdd.color1() != null)
                    a.Colour = PowerToAdd.color1();

                a.Liquids = new Liquid[]
                {
                        Liquid.GetLiquid("BLOOD")
                };
                Destroy(this.gameObject);
            }
        }

    }
}





// Originally uploaded by 'Alibarda'. Do not reupload without their explicit permission.
